      SUBROUTINE M01AJF(A,W,IND,INDW,N,NW,IFAIL)
C     NAG COPYRIGHT 1975
C     MARK 4.5 REVISED
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     SORTS A VECTOR OF REAL NUMBERS INTO ASCENDING ORDER AND
C     PROVIDES AN IN
C     INDICATING THE POSITION OF THE SORTED NUMBERS IN THE ORIGINAL
C     ARRAY.
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='M01AJF')
C     .. Scalar Arguments ..
      INTEGER           IFAIL, N, NW
C     .. Array Arguments ..
      DOUBLE PRECISION  A(N), W(NW)
      INTEGER           IND(N), INDW(NW)
C     .. Local Scalars ..
      INTEGER           I, IKO, IL1, IL2, IW, IW1, J, J1, K, L1, L2, L3,
     *                  N21, NDO, NM, NN
C     .. Local Arrays ..
      INTEGER           IST(20), KOUNT(20)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
C     .. Intrinsic Functions ..
      INTRINSIC         MIN
C     .. Executable Statements ..
      K = 0
      IF (N-1) 20, 680, 40
   20 K = 1
   40 IF (NW) 640, 640, 60
   60 IF (K) 660, 80, 660
   80 NN = MIN(N,NW)
      DO 100 K = 1, N
         IND(K) = K
  100 CONTINUE
      L3 = 1
      IKO = 0
  120 IKO = IKO + 1
  140 NM = 1
      L1 = L3
  160 L2 = MIN(L1+NM,N+1)
      L3 = MIN(L2+NM,N+1)
      KOUNT(IKO) = L3 - L1
      IST(IKO) = L1
  180 IW = 1
      IL1 = L1
      IL2 = L2
  200 NDO = MIN(IL2-L1,L3-L2,NN-IW+1)
      IF (NDO) 320, 320, 220
  220 DO 300 I = 1, NDO
         IF (A(L1)-A(L2)) 240, 240, 260
  240    W(IW) = A(L1)
         INDW(IW) = IND(L1)
         L1 = L1 + 1
         GO TO 280
  260    W(IW) = A(L2)
         INDW(IW) = IND(L2)
         L2 = L2 + 1
  280    IW = IW + 1
  300 CONTINUE
      GO TO 200
  320 IF (IL2-L1) 340, 340, 460
  340 IW1 = IW - 1
  360 DO 380 I = 1, IW1
         A(IL1) = W(I)
         IND(IL1) = INDW(I)
         IL1 = IL1 + 1
  380 CONTINUE
  400 IF (IKO-1) 420, 420, 580
  420 IF (L3-N) 440, 440, 700
  440 IKO = 2
      GO TO 140
  460 IF (L3-L2) 480, 480, 520
  480 J = L3 - 1
      K = IL2 - L1
      J1 = IL2 - 1
      DO 500 I = 1, K
         A(J) = A(J1)
         IND(J) = IND(J1)
         J = J - 1
         J1 = J1 - 1
  500 CONTINUE
      IW1 = IW - 1
      IF (IW1) 400, 400, 360
  520 J = IL2 - 1
      K = L2 - 1
      N21 = IL2 - L1
      DO 540 I = 1, N21
         A(K) = A(J)
         IND(K) = IND(J)
         K = K - 1
         J = J - 1
  540 CONTINUE
      DO 560 I = 1, NN
         A(IL1) = W(I)
         IND(IL1) = INDW(I)
         IL1 = IL1 + 1
  560 CONTINUE
      L1 = K + 1
      GO TO 180
  580 IF (L3-N) 600, 600, 620
  600 IF (KOUNT(IKO-1)-NM-NM) 620, 620, 120
  620 IKO = IKO - 1
      NM = KOUNT(IKO)
      L1 = IST(IKO)
      GO TO 160
  640 K = K + 2
  660 IFAIL = 1
      RETURN
  680 IND(1) = 1
  700 IFAIL = 0
      RETURN
      END
