c Uncoupled asymptotic wave functions!
c
       Subroutine Asyuwfn(r,Nstate,EEE,f,fp)
	use globals
	use scattering
	implicit real*8 (a-h,o-z)
      	real*8 FF(KKMAX),GG(KKMAX),FD(KKMAX),GD(KKMAX),
     X	  f(Nstate,Nstate,2),fp(Nstate,Nstate,2)

	it = 1
	 do 5 i=1,Nstate
	 do 5 j=1,Nstate
         f(i,j,1) = 0d0
         f(i,j,2) = 0d0
         fp(i,j,1) = 0d0
  5      fp(i,j,2) = 0d0
C****************************************************** Coulomb Wavefunctions
C   (neglecting couplings beyond Rmax)
	do 50 i =1,Nstate
	echan = EE - ecores(i)
       	WVK = sqrt(abs(echan/ryev))
	  rmk = r * WVK
	  etaq = etap/(2d0 * WVK)
          lj = lchl(i)
      	  flj = dble(lj) + scent
      	  fl0 = flj - int(flj)
	  lj1 = 1 + scent
	if(echan.gt.0) then
      	  call  coulfg(rmk,etaq,fl0,flj,ff,gg,fd,gd,1,0,ifl,m1)
	  f(i,i,1) = FF(lj+lj1) 
	  fp(i,i,1) = WVK * FD(lj+lj1) 
	  f(i,i,2) = GG(lj+lj1) 
 	  fp(i,i,2) = WVK * GD(lj+lj1) 
	  if(prkm) then
	   write(6,10) i,(f(i,i,is),is=1,2),EE,echan,WVK,rmk,etaq
10	   format(' For ch',i3,', F,G =',2f10.5,' for E,Ei,K,r*k,eta ='
     X			,5f10.5)
	  endif
        else
	  zz = -etaq*WVK
	  call coul (flj,zz,echan/ryev,r,u,uder)
	  f(i,i,1) = u 
	  fp(i,i,1) = uder 
	  if(prkm) then
	   write(6,20) i,u,uder,EE,echan,WVK,rmk,etaq
20	   format(' For ch',i3,', W,W''=',2f10.5,' for E,Ei,K,r*k,eta ='
     X			,5f10.5)
	  endif
	endif
 50	continue
	return
	end
	subroutine nopen(Nstate,EEE,iop,nop)
	use globals
        implicit real*8 (a-h,o-z)
        integer iop(Nstate)

	nop = 0
	do 50 i =1,Nstate
	echan = EE - ecores(i)
	if(echan.gt.0) then
	  nop = nop + 1
	  iop(nop) = i
	  endif
50	continue
	return
	end
	subroutine nopen2(Nstate,EEE,iop,nop,ktransmax,iog,nog)
	use globals
        implicit real*8 (a-h,o-z)
        integer iop(Nstate),iog(Nstate)

	nop = 0
	nog = 0
	do 50 i =1,Nstate
	echan = EE - ecores(i)
	if(echan.gt.0) then
	  nop = nop + 1
	  iop(nop) = i
	  if(lchl(i).le.ktransmax) then
	   nog = nog + 1
	   iog(nog) = i
	  endif
	  endif
50	continue
	return
	end
