      SUBROUTINE BOUNDC (NC,ETHR,NS,MGVN,GUTOT,ABOUND,EBND,PSI,NR,
     X                   LCHL,CF,MCHAN,BBLOCH,PRBC,LMAX,
     X                   EBMAX,EBMIN,EIG,WMAT,E0,RMAT,NPOLE,
     X                   ECORES,RAFIN,RADWM,RMATR,PRWR,PRWF,LWSECT,
     X                   APFLG,APEPS,IASY,DEGENY,IPMAX,EWRON,NCOL,
     X                   PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                   NFINAL,LWGF,WFIN,RSTEP)
      IMPLICIT INTEGER (A-Z)
      LOGICAL WFIN,PRBC,PRWR,PRWF,PROP,DEBUG
      REAL*8 ETHR,E0,ET,RMAT,ABOUND,EIG,WMAT,RADWM,BBLOCH,
     X       ECORES,CF,EBMAX,EBMIN,DEGENY,EWRON,F,FP,APEPS,RAFIN,
     X       DEPLIM,RSTEP,EBND,LWSECT,PSI,RMATR
      DIMENSION ETHR(*),LCHL(*),RMAT(NC,NC),ABOUND(*),
     X          EIG(*),WMAT(*),ECORES(*),CF(MCHAN,MCHAN,IPMAX),ET(nc),
     X          LWKEEP(LWRAN),KEEP(LWRAN),F(nc,nc,4),FP(nc,nc,4),
     X          APFLG(5),LWSECT(*),LWGF(*),PSI(*)
      COMMON /IO/ IIN,IOUT
*
*     Bound state calculation of eigenenergy, E0M, and wavefunction
*     expansion coefficients projected onto asmptotic channels
*
      CALL BNDBS (NC,ETHR,NS,MGVN,GUTOT,ABOUND,
     X           IBND,EBND,LCHL,CF,MCHAN,BBLOCH,F,FP,ET,LMAX,
     X            EBMAX,EBMIN,EIG,WMAT,E0,RMAT,PSI,NR,
     X            NPOLE,ECORES,RAFIN,RADWM,RMATR,PRWR,PRWF,
     X            APFLG,APEPS,IASY,DEGENY,IPMAX,EWRON,NCOL,
     X            PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X            NFINAL,LWSECT,LWGF,WFIN,RSTEP)
*     print expansion coefficients
      IF (PRBC.and.IBND.gt.0) THEN
c        WRITE (IOUT,1000) (K,ABOUND(K),K = 1,NS)
         WRITE (IOUT,1000) (ABOUND(K),K = 1,NS)
c         WRITE (IOUT,1010)
c         DO 10 J = 1, NC
c            IP = AP - 1 + ( J - 1 ) * NS
c            WRITE (IOUT,1020) ,LCHL(J),
c     X                        (K,X(IP+K),K = 1,NS)
c   10    CONTINUE
      ENDIF
      RETURN
*
 1000 FORMAT (' Coefficients of B.S. Wfn in Internal Region :',/,
c    X        1P,(5(I6,D16.8)))
     X           (8F10.5))
c 1010 FORMAT (' CHANNEL PROJECTED B.S. COEFFICIENTS :')
c 1020 FORMAT (' I =',I3,'  V =',I3,'  L =',I3/(5(I6,D16.8)))
      END
      SUBROUTINE BNDBS (NC,ETHR,NS,MGVN,GUTOT,A,
     X                  IBND,EBND,LCHL,CF,MCHAN,BBLOCH,V,VP,ET,LMAX,
     X                  EBMAX,EBMIN,EIG,WMAT,E0,RMAT,PSI,NR,
     X                  NPOLE,ECORES,RAFIN,RADWM,RMATR,PRWR,PRWF,
     X                  APFLG,APEPS,IASY,DEGENY,IPMAX,EWRON,NCOL,
     X                  PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                  NFINAL,LWSECT,LWGF,WFIN,RSTEP)
      use gs
      use gailitis, only: nulim
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PRWR,PRWF,PROP,DEBUG,WFIN
      INTEGER GUTOT,APFLG
      PARAMETER (ZERO=0.0D0,ONE=1.0D0,HALF=0.5D0,OVFL=306.0D0)
c     X            TINY=1.0D-200 )
      REAL*8 RSTEP,LWSECT
      DIMENSION ETHR(NC),ET(NC),UT(NC,NC),B(NC,NC),RMAT(NC,NC),V(NC,NC),
     X          VP(NC,NC),VQ(NC,NC),A(NS),IPVT(NC),C(NC,NC),
     X          EIG(*),WMAT(MCHAN,NS),Y(NC),ECORES(NC),PSI(MCHAN,NR),
     X          CF(MCHAN,MCHAN,IPMAX),LCHL(NC),DETC(2),WRERR(2),
     X          LWSECT(LWRAN),LWKEEP(LWRAN),KEEP(LWRAN),LWGF(LWRAN),
     X          WFNR(MCHAN,MCHAN,NR),APFLG(5)
      real*8 scent,ryev
      common /cent/ scent,ryev
      common /IE/ EE,IERR
      COMMON /IO/ IIN,IOUT
      NAMELIST /BSTATE/ NE,EMIN,EMAX,KPOLE,EPS,IDIAG,IBSLT,NUMAXGS
	ABL(R) = LOG10(MAX(ABS(R),1D-50))
*
*     BNDBS : energy and expansion coefficients for bound states
*
c			Local defaults
        NE = 10
        KPOLE = 1
        IDIAG = 1
        EPS = 1D-5
	NUMAXGS = 0
c			Defaults from inputs to main sturmx program
	EMIN = egsmin
	EMAX = egsmax
	IBSLT = ngsmax
c			Find lower state between egsmin and egsmax?
	EB = EIG(KPOLE)
	do i=1,NS
	  if(EIG(i).ge.egsmin.and.EIG(i).le.min(EB,egsmax)) then
		EB = EIG(i)
	        KPOLE = i
	  endif
	enddo
      read (IIN,BSTATE,IOSTAT=ios,end=2,err=2)
   2  if ( ios .ne. 0 ) then
         write (iout,*) ' Input namelist read errror: ',IOS
         write (iout,BSTATE)
         stop
      endif
c			Necessary for now!
c????	IBSLT = 1

	RMATCH = RMATR
	NMATCH = 1
	NUMAXG = IPMAX
	if(NUMAXGS.gt.0) NUMAXG = min(IPMAX,NUMAXGS,nulim)
	nulim = NUMAXG
	if(NE.lt.1) return
      WRITE(IOUT,'(/''Bound state search:'')')
      WRITE(IOUT,5) KPOLE,NUMAXG
5     format('  Looking for gs around KPOLE =',i3,
     X		', with Gailitis couplings up to order',i3)
      EMIN = EMIN/ryev
      EMAX = EMAX/ryev
*
      NCQ = NC - 1
      IF (KPOLE .NE. 0) THEN
         KKMIN = KPOLE
         KKMAX = KPOLE
         GO TO 20
      ENDIF
      ISET = 0
      DO 10 I = 1, NS
         IF (EMIN .LT. EIG(I)/ryev .AND. ISET .EQ. 0) THEN
            KKMIN = I
            ISET = 1
         ENDIF
         IF (EMAX .LT. EIG(I)/ryev) THEN
            KKMAX = I - 1
            GO TO 20
         ENDIF
   10 CONTINUE
   20 IF (KKMAX .LT. KKMIN) THEN
         WRITE (IOUT,1000) EMIN,EMAX,KKMIN,KKMAX
         STOP
      ENDIF
      IBND = 0
      DO 300 KK = KKMIN, KKMAX
         NPOLE = KK
         IMODE = 1
         IF (KK .EQ. KKMIN) THEN
            ETOT1 = EMIN
         ELSE
            ETOT1 = HALF * (EIG(KK-1) + EIG(KK))/ryev
         ENDIF
         IF (KK .EQ. KKMAX) THEN
            ETOT2 = EMAX
         ELSE
            ETOT2 = HALF * (EIG(KK) + EIG(KK+1))/ryev
         ENDIF
c         NUM1 = NE + 1
         NUM1 = NE
         ENUM = DBLE(max(NUM1-1,1))
         EINC = (ETOT2 - ETOT1) / ENUM
         WRITE (IOUT,1100) ETOT1*ryev,ETOT2*ryev,NE,EPS,KK
         ETOTS = ETOT1
	 XK = sqrt(abs(EIG(KK))/ryev)
c	 D1 = EIG(KK) - ryev*WMAT(1,KK)**2*(-XK-BBLOCH/RMATR)
c	 write(6,*) ' WMAT(1:3,',KK,') =',(real(WMAT(I,KK)),I=1,3)
c	 write(6,*) ' Channel 1, 1-term shift gives gs @',real(D1)
      IF(NS.gt.0 ) THEN
*     compute transpose U
            GSQJ2 = WMAT(1,KK)**2
            DO 120 I = 1, NCQ
               GJP1 = WMAT(I+1,KK)
               GSQJ1 = GSQJ2
               GSQJ2 = GSQJ2 + GJP1**2
               D1 = ONE / SQRT(GSQJ1*GSQJ2)
               D2 = GJP1 * D1
               DO 100 J = 1, I
                  UT(I,J) = D2 * WMAT(J,KK)
  100          CONTINUE
               UT(I,I+1) = - D1 * GSQJ1
               IF ( I .LT. NCQ ) THEN
                  DO 110 J = I+2, NC
                     UT(I,J) = ZERO
  110             CONTINUE
               ENDIF
  120       CONTINUE
            D1 = ONE / SQRT(GSQJ2)
            DO 130 J = 1, NC
               UT(NC,J) = D1 * WMAT(J,KK)
  130       CONTINUE
            GAMM = SQRT(GSQJ2)
	if (IDIAG.ge.3) then
		WRITE(6,*)  ' GAMM =',real(GAMM)
	        if (IDIAG.ge.4) then
		  write(6,*) 'UT:'
		  CALL WRTMAT(UT,NC,NC,NC,7)
		  endif
	 endif
	ENDIF
*
*     E = scattering energy in Rydbergs ; ET = channel energies
*     ETOT = total energy in Hartrees
*
         DO 290 IE = 1, NUM1
            ETOT = ETOTS
   40       E = (ETOT - E0)
            DO 50 N = 1, NC
               ET(N) = E - ETHR(N)
               IF (ET(N) .GT. ZERO) GO TO 280
   50       CONTINUE
	    EE = E*ryev
!        write(*,*) 'Try bs at ',real(E),real(EE)
        NOP = 0
*     R-Matrix
	if(NS.gt.0) THEN
c           CALL RMATB (NS,NC,NPOLE,EIG,WMAT,E0,CFBUT,BUTTLE,
c    X                  ECORES,RMATR,E,RMAT,EBMAX,EBMIN)
c No Buttle:
            CALL RMATB (NS,NCHAN,NPOLE,EIG,WMAT,E0,RMATR,E,RMAT)
	 ELSE
**      R-matrix from ADW near origin (for negative energy)
            CALL RADW (NC,RMATR,RMAT,LCHL)
	 ENDIF
*
**      Wave function from RAFIN to RMATCH inward (NFINAL to NMATCH)
            CALL ASYMB (E,NC,LCHL,CF,MCHAN,BBLOCH,V,VP,ET,LMAX,
     X                  NOP,RAFIN,RMATCH,PRWR,PRWF,WRERR,
     X                  APFLG,APEPS,IASY,DEGENY,NUMAXG,EWRON,NCOL,
     X                  PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                  LWSECT,NMATCH,NFINAL,WFIN,LWGF,WFNR,NR)
*
*     construct C matrix : C = V - RMAT * ( RMATCH * VP - BBLOCH * V)
            DO 70 J = 1, NC
               DO 60 I = 1, NC
                  VQ(I,J)= RMATCH * VP(I,J) - BBLOCH * V(I,J)
   60          CONTINUE
           IF(IDIAG.eq.6) write(iout,*) 'V:',(V(J,I),I=1,NC)
		call flush(6)
   70       CONTINUE
           IF(IDIAG.ge.3) write(iout,*) 'VP/V(1):',VP(1,1)/V(1,1)
		call flush(6)
***                                      form B(E) = V - R.Q
            CALL VMUL (RMAT,VQ,C,NC,NC)
            DO 90 J = 1, NC
               DO 80 I = 1, NC
                  C(I,J) = V(I,J) - C(I,J)
   80          CONTINUE
           IF(IDIAG.eq.6) write(iout,*) 'RMAT:',(RMAT(J,I),I=1,NC)
		call flush(6)
   90       CONTINUE
*
      IF(NS.gt.0) THEN
*     form B-matrix
            CALL VMUL (UT,C,B,NC,NC)
            EK = EIG(KK)/ryev - ETOT
	  if(IDIAG.ge.2)
     X	write(6,*) 'e1-E,F,F''=',real(EK),V(1,1),VQ(1,1)
            DO 150 J = 1, NC
               SUM = ZERO
               DO 140 I = 1, NC
                  SUM = SUM + VQ(I,J) * WMAT(I,KK)
  140          CONTINUE
		 D2 = B(NC,J)
               B(NC,J) = EK * B(NC,J) - GAMM * SUM / RMATCH
	  if(IDIAG.ge.3.and.J.eq.1) then
	write(6,*) 'G*f1,Bi,Bf=',real(GAMM*SUM),real(D2),real(B(NC,1))
	  endif
  150       CONTINUE
	 ELSE
	   DO 160 I=1,NC
	   DO 160 j=1,NC
  160      B(I,J) = C(I,J)
	 ENDIF
	 if (IDIAG.ge.3) WRITE(6,*) ' B matrix'
	 if (IDIAG.ge.3) CALL WRTMAT(B,NC,NC,NC,7)
*
*     form DET(B)
            CALL DGETRF (NC,NC,B,NC,IPVT,IER)
c       write(*,*) ' DGETRF, IER=',IER,(IPVT(I),I=1,min(NC,4))
            IF (IER .NE. 0) THEN
               WRITE (IOUT,1010) IER
               STOP
            ENDIF
	 if (IDIAG.ge.3) WRITE(6,*) ' B matrix in LU form'
	 if (IDIAG.ge.3) CALL WRTMAT(B,NC,NC,NC,7)
            CALL DGEDT (B,NC,NC,IPVT,DETC)
         if(IDIAG.ge.3) write(*,*) ' DGEDT, DETC=',DETC
            IF (abs(DETC(2)) .le. OVFL) THEN
c           WRITE (43,*) ETOT*ryev,DETC(1)*10d0**DETC(2)
            WRITE (43,*) ETOT*ryev,
     X		sign(1d0,DETC(1))*(log10(abs(DETC(1)))+DETC(2))
            ENDIF
            DETB = SIGN(ONE, DETC(1))
            IF (IDIAG .GE. 1) WRITE (3,1500) ETOT*ryev,
     X                         DETB,DETC,WRERR
            IF (IDIAG .GE. 1) WRITE (IOUT,1502) ETOT*ryev,
     X                  DETC(1),nint(DETC(2)),WRERR
c    X                  ,KEEP(2),KEEP(NMATCH),KEEP(NMATCH+1),
c    X                         KEEP(NFINAL-1)
            IF (IDIAG .GE. 1) CALL FLUSH(IOUT)
*
            IF (IMODE .EQ. 1) THEN
               IF (IE .EQ. 1) THEN
                  SGN = DETB
               ELSEIF (IE .GT. 1 .AND. SGN*DETB .LT. ZERO) THEN
                  SGN = DETB
                  IBND = IBND + 1
                  EUP = ETOT
                  ELOW = ETOT - EINC
                  IMODE = 2
                  ETOT = HALF * (ELOW + EUP)
                  GO TO 40
               ENDIF
            ELSE
               IF (SGN*DETB .LT. ZERO) THEN
                  ELOW = ETOT
               ELSE
                  EUP = ETOT
               ENDIF
               IF (ABS(EUP-ELOW) .LT. EPS) THEN
                  EBND = HALF * (EUP + ELOW) *ryev
                  WRITE (IOUT,1200) IBND,EBND
c                 WRITE (0,1200) IBND,EBND
*
*    compute wavefunction
                     DO 185 I = 1, NC
                        if(NS.gt.0) A(I) = WMAT(I,KK)
                        if(NS.eq.0) A(I) = 1.0/I
  185                CONTINUE
                     CALL DGETRF (NC,NC,C,NC,IPVT,IER)
                     IF (IER .NE. 0) THEN
                        WRITE (IOUT,1010) IER
                        STOP
                     ENDIF
                     CALL DGETRS('N',NC,1,C,NC,IPVT,A,NC,IER)
                     IF (IER .NE. 0) THEN
                        WRITE (IOUT,1020) IER
                        STOP
                     ENDIF
*     wave function outside RMATR:
			write(152,*) 'ASYMP',(A(K),K=1,NC)
			D1 = ZERO
		     DO 210 IR=1,NR
                     DO 200 I = 1, NC
                        SUM = ZERO
                        DO 190 K = 1, NC
                           SUM = SUM + WFNR(I,K,IR) * A(K)
  190                   CONTINUE
			  D1 = D1 + SUM**2 * RSTEP
  200                   PSI(I,IR) = SUM
		     write(153,205) IR,(ABL(PSI(i,IR)),i=1,min(NC,16))
  205			format(i4,16f8.3)
  210                CONTINUE
			write(152,*) 'ASYMPTOTIC WFN NORM',D1
		     if(NS.eq.0) then
			D1 = ONE/sqrt(D1)
		     DO 220 IR=1,NR
                     DO 220 I = 1, NC
  220                   PSI(I,IR) = PSI(I,IR) * D1
		     endif
	           
*     multiply expansion coefficients, X, and VQ
                     DO 350 I = 1, NC
                        SUM = ZERO
                        DO 340 K = 1, NC
                           SUM = SUM + VQ(I,K) * A(K)
  340                   CONTINUE
                        Y(I) = SUM
  350                CONTINUE
*     form wavefuntion expansion coefficients, A
                     DO 330 K = 1, NS
                        FAC = ONE / (EIG(K)/ryev - ETOT)
                        SUM = ZERO
                        DO 320 J = 1, NC
                           SUM = SUM + WMAT(J,K) * Y(J)
  320                   CONTINUE
                        A(K) = FAC * SUM
  330                CONTINUE
			write(152,*) 'INTERNAL COEFS',(A(K),K=1,NS)
*     normalize the wavefunction expansion coefficients
                     SUM = ZERO
                     DO 332 K = 1, NS
                        SUM = SUM + A(K) ** 2
  332                CONTINUE
                     FAC = ZERO
                     if(NS.gt.0) FAC = ONE / SQRT(SUM)
c					So A(NPOLE) > 0
			FAC=SIGN(FAC,A(NPOLE))
                     DO 335 K = 1, NS
                        A(K) = FAC * A(K)
  335                CONTINUE
                     WRITE (3,1300) IBND,NS,(K,A(K),K=1,NS)
                     IF (IBND .EQ. IBSLT) RETURN
                  IMODE = 1
                  GO TO 280
               ENDIF
               ETOT = HALF * (ELOW + EUP)
               GO TO 40
            ENDIF
  280       ETOTS = ETOTS + EINC
  290    CONTINUE
  300 CONTINUE
      RETURN
*
 1000 FORMAT (' INCONSISTENT ENERGIES FOR BOUND STATE SEARCH',/,
     X        ' EMIN =',D16.8,' EMAX =',D16.8,' KKMIN =',I6,' KKMAX =',
     X        I6)
 1010 FORMAT (' BNDBS : ERROR RETURN FROM DGETRF, IER =',I4)
 1020 FORMAT (' BNDBS : ERROR RETURN FROM DGETRS, IER =',I4)
 1012 FORMAT (' BNDBS: ERROR RETURN FROM DGETDT, DET =',2F12.6)
 1100 FORMAT (' ETOT1 =',G13.5,' ETOT2 =',g13.5,' NE =',
     X        I4,' EPS =',1p,e10.2,' @ KK =',I4)
 1200 FORMAT (' BOUND STATE ',I3,' : engy =',f12.5,' MeV ; ',:,
     X        'N* =',D16.8)
 1250 FORMAT (' IBND =',I4,' EBND =',F12.6,' E0 =',F12.6,' N* =',
     X        F12.6)
 1300 FORMAT (' IBND =',I6,' NS =',I6,/,
     X       ' Bound state expansion coefficients, A :',/,
     X        (3(I6,D16.8,5X)))
 1500 FORMAT (' Etot =',F12.5,', detb =',F6.2,' from',F7.3,'*10^',F7.0,
     X        ',  mWe =',1p,2D11.2)
 1502 FORMAT (' E =',F10.5,', det =',F6.2,'*10^',I5,
     X        ',  mWe =',1p,2D10.2,4i3)
 2000 format (' Wavefunction Expansion Coefficients:')
 2010 format (' i = ',i4,' X =',d16.8,' sum =',d16.8)
 2020 format (4d16.8)
      END
      SUBROUTINE RMATB (NSTAT,NCHAN,NPOLE,EIG,WMAT,E0,RMATR,E,RMAT)
      IMPLICIT INTEGER (A-Z)
      REAL*8 EIG,WMAT,E0,RMATR,E,RMAT,ZERO,ETOT,SUM
      PARAMETER ( ZERO=0.D0)
      DIMENSION RMAT(NCHAN,NCHAN),EIG(NSTAT),WMAT(NCHAN,NSTAT)
      COMMON /IO/ IIN,IOUT
      real*8 scent,ryev
      common /cent/ scent,ryev
*
*     RMATRB : NCHAN-channel bound-state R-matrix for energy ETOT
*
      ETOT = E0 + E
      DO 70 I2 = 1, NCHAN
         DO 60 I1 = 1, I2
            SUM = ZERO
            DO 50 I = 1, NSTAT
            IF ( I .NE. NPOLE ) THEN
             SUM = SUM + WMAT(I1,I) * WMAT(I2,I) / (EIG(I) - ETOT*ryev)
            ENDIF
   50       CONTINUE
            RMAT(I1,I2) = SUM * ryev/RMATR
            RMAT(I2,I1) = SUM * ryev/RMATR
   60    CONTINUE
   70 CONTINUE
      RETURN
      END
      SUBROUTINE VMUL(A,B,C,M,N)
      IMPLICIT INTEGER (A-Z)
      REAL*8 A,B,C,ZERO,ONE
      PARAMETER ( ZERO=0.0D0,ONE=1.0D0 )
      DIMENSION A(N,M),B(M,N),C(N,N)
*
*     VMUL : MULTIPLIES N*M MATRIX A BY M*N MATRIX B, RESULT IN C
*
      call dgemm ('n','n',n,n,m,one,a,n,b,n,zero,c,n)
      RETURN
      END
**      R-matrix from ADW near origin (for negative energy)
      SUBROUTINE RADW (NCHAN,RMATR,RMAT,LCHL)
      IMPLICIT INTEGER (A-Z)
      REAL*8 RMATR,RMAT,ZERO,ONE
      real*8 u,uder,flj
      PARAMETER ( ZERO=0.D0,ONE=1d0)
      DIMENSION RMAT(NCHAN,NCHAN)
      COMMON /IO/ IIN,IOUT
      dimension lchl(nchan)
      real*8 scent,ryev
      common /cent/ scent,ryev
*
*     RMATRB : NCHAN-channel bound-state R-matrix for energy ETOT
*
      DO 70 I2 = 1, NCHAN
         DO 60 I1 = 1, I2
            RMAT(I1,I2) = ZERO
            RMAT(I2,I1) = ZERO
	    IF(I1.EQ.I2) THEN
             flj = lchl(i2)+scent
c       Series expansion from the origin gives u = const * rmatr**(flj+1)
             u =  rmatr**(flj+ONE)
	     uder = (flj+ONE) * rmatr**flj
             rmat(I2,I2) = u/(rmatr * uder)
c	     write(*,*) 'RADW @',real(rmatr),':',
*    x            real(u),real(uder),
c    x         ' so rmat(',I2,') =',real(rmat(i1,i2))
	    ENDIF
   60    CONTINUE
   70 CONTINUE
      RETURN
      END
