	module parameters
	integer mchan,mchan3,nmax,numrmax,nmaxf,nchmax
	integer meigs,mtarg,mintl
!  We can always assume that mchan==mchan3==nchan,
!			     nmax == nsturm
!			     numrmax = numr
!			     nchmax  == nch
      	common /io/ iin,iout 
	real*8 ee
	common /ie/ ee,ierr
!  ftn90 KINDs of real declarations:
	integer, parameter :: low=selected_real_kind(5)
	integer, parameter :: med=selected_real_kind(12)
	integer, parameter :: high=selected_real_kind(20)
	end module parameters

	module globals
	use parameters
	implicit real*8(a-h,o-z)
! derivative  and misc. parameters:
	parameter (nkind=10)

!  Specification of problem:
	real*8 rmt,coulcn,etap,escatt
	common/cent/scent,ryev
	character sturm(2),EQN
	character*3,save,allocatable:: qnum(:)
	character*8,save,allocatable:: name(:)
	logical details
	logical, save,allocatable:: id(:)
	real*8, save,allocatable:: radius(:),iso(:),Qmom(:),Mmom(:),
     X		CoreK(:),energy(:,:),mass(:),charge(:),ecores(:)
	integer, save,allocatable:: cupord(:,:),mult(:),npstates(:),
     X		nparity(:,:),nucl(:,:)
	integer, save,allocatable:: ichl(:,:),lchl(:),kfad(:),icop(:),
     X 		lxtr(:,:),mp12(:),initl(:)
	integer ncoup,mfad,buttle,fadex,lxtra,nbody,slorder,nmom,
     X		kdiag,nidiag,nlam(20)
	real*8 vdiag(2),rdiag(2),adiag

      	real*8, save,allocatable:: cf(:,:,:,:),wn1(:,:),moms(:,:,:)
	integer ipmax,numax,iwfskp,parity,tt,ttnc,npots,solve
	integer numrs,numrs1
	real*8 Vsturm,RRsturm,asturm,Eo(2),Rmax,rmaxi,step,beta,
     &         rmaxsc,rinner,alf,stepi,eeigmax,potcoef(10)
	real*8 jtot
      	common /ccset/ jtot,npty
	
!  Solution of problem:
	logical pralpha,pripot,prsturm,prmats,prtran,onormal
	logical simeq,GO,fad,symm,glag,pertcent,prns,GONE
	integer kind,kindi,kst,lprwf,kkmax
	real*8 steps,tmass,cutl,cutr,phtlast,phtadd
      	real*8, save,allocatable:: rrad(:),wrad(:)
	integer nsturm,numr,nch,neigs,nmaxb,nsturmi
 	character psign(3),fads(4)
      	data psign / '-','?','+' /, fads / 'T','Y','X','M' /
	end module globals

	module gs
	real*8 egs,egsmin,egsmax,stepgs
	integer numgs,ngsmax,maxset,nccset,pariti,nstgs,ttgs
	logical xlrgs
        integer,save,allocatable::  kstgs(:,:),kfadgs(:),ichgs(:,:)
        real*8 jtoti
      	real*8, save,allocatable:: rrade(:),wrade(:)
        real*8,save,allocatable:: PsiGSe(:,:)
	end module gs

	module gailitis
	  real*8, save,allocatable:: gaa(:,:,:),gba(:,:,:)
	  integer nulim
	end module gailitis

	module pauli
	logical occ2
	integer nsrc,nrpp,mblock,nkill,nblock
	real*8 efermi,ppro,ppdr
	end module pauli

	module scattering
	logical prrm,prkm,prtm,asymp,prbut,doscat,discrete,
     &		wfs,e1only,prrexp,nogscat,strfun,elinear
	real*8 ebeg,estep,emax,wfrmax,turnmax,rafin,rafini,tinside
	real*8 rinte,rtrans,htrans
	integer mnop,minnop,maxnop,mtrans,mlpr,ktransmax,ltransmax
	end module scattering

	module xlrm
      	character*80 flwp,flwpr
      	logical cmon,prop,prwf,prwr,prbc,debug,prntv,prntr
      	integer ipflg,apflg(5),nftt,idiscr,ncol,iasy,maxtry,msurf
      	integer ion
      	real*8 abvthr,belthr,ewron,betalw,cuplim,deplim,degeny,apeps,
     x		  gfact,rfact,rafix
	end module xlrm
