      SUBROUTINE SEARCH8(NODES,LT,NMAX,H,H2SM,U,BE,
     X W,Z,Y,SCON,PCON,IFAULT,NCMIN,NCMAX)
      implicit real*8(a-h,o-z)
      PARAMETER(IMP=2, ERROR=0.00001, ERROR2=0.002, CUTL = 1.6)
      REAL*8 INTT,INTP,K,KP,LOGD,LM
	real*8 LT
      INTEGER BC,COUNT,CC,CCP,PCON,SCON
      LOGICAL L1,L4
      DIMENSION Y(NMAX+1),W(NMAX+1),Z(NMAX+1)
      NMAXP=NMAX+1
      IFAULT = 0
      CONV=1./H2SM
      HP=H*H
      LM=(LT+1)*LT
      Y(1)=1.
      Y(1)=H**LT
      NT=-1
      COUNT=1
      RATIO=1.
      CCP=1
      BC=0
      L1=SCON.EQ.1
      L4=SCON.EQ.2
      IF(L1) PPP=U
      IF(L4) PPP=BE
      P=PPP
      PP=PPP
      IF(PCON.GE.3)WRITE(IMP,207)
  207 FORMAT(/37H    PARAMETERS      MISMATCH    NODES   )
  102 KP=BE/H2SM
      K=SQRT(ABS(KP))
      B=NMAXP*H
      C=B-H
      PIB=K*B
      PIC=K*C
C                 Use logarithmic derivative -K at Rmax
	Y(NMAXP)= 1d-50
	Y(NMAXP-1)=Y(NMAXP) *(1d0 + K * H)
  103 DEL=0.
      NS=NMAXP-1
      INTT=0.
      INTP=0.
      Y(1)=Y(1)*RATIO
      RATIO=1.
      NCO=1
      NU=0
      T=0.
      TP=0.
      G3=-LM/(NMAXP*NMAXP)-(W(NMAXP)*U+Z(NMAXP)+KP)*HP+12.
      N=NS
   31 G1=G2
      G2=Y(N-NT)*G3
      G3=-LM/(N*N)-(W(N)*U+Z(N)+KP)*HP
      IF(NU.eq.0) THEN
        IF ((G3.GE.0.OR. N.LT.10).and.N.LT.NMAX-5)NU=N
        IF(KP.lt.0.)            NU=NMAXP/4
       ENDIF
      G3=G3+12.
      IF(N.EQ.1.AND.LT.EQ.1)G2=-2*Y(1)
      I=N-NT
      IF(N.NE.NS) Y(N)=((16.*Y(I)-G2)*9.0-G2-G1)/G3
      X=Y(N)**2
       IF(L1) DV=W(N)
       IF(L4) DV=CONV
      T=T+X*DV
      TP=X+TP
      IF(Y(N)*Y(I).LT.0.0 .AND. N.gt.NCMIN.and.N.lt.NCMAX)NCO=NCO+1
      IF(N.EQ.NU)GO TO 41
      N=N+NT
      GO TO 31
   41 TP=TP-0.5*X
      CC=NU-NT
      N=CC-NT
      NS=N-NT
      LTT=NS-NT
      I=LTT-NT
      IFA=I-NT
      LOGD=147.0*Y(NU)-360.0*Y(CC)+450.0*Y(N)
     1 -400.0*Y(NS)+225.0*Y(LTT)-72.*Y(I)+10.*Y(IFA)
      LOGD=NT*LOGD/(60.0*Y(NU)*H)
      NT=-NT
      NS=1
      DEL=-LOGD-DEL
      RATIO=1.0/(RATIO*Y(NU))
      INTT=T/X+INTT
      INTP=TP/X+INTP
      IF(NT.LE.0) GO TO 3
      X=Y(1)**2
       IF(L1) DV=W(1)
       IF(L4) DV=CONV
      T=X*DV
      TP=X
      N=2
      G2=0
      IF(LT.EQ.1)G2=-2*Y(1)
      G3=-LM-(W(1)*U+Z(1)+KP)*HP+12.
      GO TO 31
    3 COUNT=COUNT+1
      IF(ABS(INTT).gt.1d300) go to 200
      INTP=INTP*X*RATIO*RATIO
      IFAULT=0
      IF(COUNT.GT.50)GO TO 200
      IF(PCON. GE.3) WRITE(IMP,217)P,DEL,NCO
C  217 FORMAT(E14.6,E15.3,I6)
  217 FORMAT(F14.6,F15.6,I6)
      IF(NCO.NE.NODES) GO TO 6
      IF(ABS(DEL).LT.ERROR)GO TO 7
C      IF(ABS(DEL).LT.ERROR2.and.COUNT.ge.15)GO TO 7
      Q=DEL/(INTT*H)
C      IF(abs(P).LT.Q)Q=P
C      IF(abs(P).LT.-Q)Q=-0.5*P
C      P=P+Q
   50 P1 = P+Q
       IF(ABS(P1).gt.2.*ABS(P) .or. ABS(P1).lt.0.5*ABS(P)
     X     .or. P1*P.lt.0.) THEN 
         Q=0.5*Q
         GO TO 50
         ENDIF
       P = P+Q
      BC=1
      Q=2*Q
   51 IF(L1) THEN
       U = P
c      GO TO 103
       GO TO 102
      ELSE
       BE=P
       GO TO 102
      ENDIF
    6 IF(BC.NE.0)GO TO 61
      CC=1
      IF(NODES.LT.NCO)CC=-1
 
      IF(L4.and.KP.gt.0.) CC=-CC
      IF(CC.LT.0)CCP=-IABS(CCP)
      IF(CCP.GT.0)PP=P
      IF(CCP.LT.0)PP=0.5*PP
      P=PP*CC+P
      GO TO 51
   61 Q=0.5*Q
      P=P-0.5*Q
      GO TO 51
    7 INTP=INTP*H
      IF(KP.gt.0.) THEN
        X=NMAXP*H*K
        T=Y(NMAXP)**2
        LTT=LT+1
C        G3=IHL1(LTT,X)/IHL1(LT,X)
C        INTP=(((G3*X-LT*2-1)*G3-X)/K-H)*T*0.5+INTP
       ENDIF
      INTP=SQRT(1.0/INTP)
 
      DO 8 N=1,NMAX
      X=N*H
      T=1.
      IF(N.LE.NU)T=RATIO
      Y(N)=Y(N)*INTP*T
c	write(4,*)  N,Y(N),T,INTP
C   ------------------- Scale by 1/r if required:
C      Y(N)=Y(N)/X
    8 CONTINUE
C      IF(SCON.LT.10)WRITE(IMP,991)PP,P
      IF(PCON.gt.0)WRITE(IMP,991)P,COUNT,K
C 991 FORMAT(///' BE ',12H VARIED FROM,F9.5,4H TO ,F9.5)
  991 FORMAT(' BOUND STATE AT',G10.3,' (AFTER',I3,' ITERATIONS)',
     X  ', K =',F8.3)
      IF(PCON.lt.0.or.MOD(PCON,2).EQ.0)RETURN
      WRITE(IMP,992)
  992 FORMAT(//20H   N     R      Y(R))
      WRITE(IMP,998)(N,N*H,Y(N),N=10,NMAX,10)
  998 FORMAT(4(I4,F8.3,2X,E11.4,3X))
      RETURN
  200 IFAULT = 1
C     WRITE(IMP,986) IFAULT
  986 FORMAT(32H PROGRAM FAILURE- ROUTINE SEARCH,I5)
      WRITE(IMP,992)
      WRITE(IMP,998)(N,N*H,Y(N),N=1,NMAX)
C     IFAULT=IFAULT/0
C     STOP
      RETURN
      END
