      SUBROUTINE SEARCH9(NODES,LT,NMAX,H,H2SM,U,EIG,BETA,
     X W,Z,Y,SCON,PCON,IFAULT,NCMIN,NCMAX)
      implicit real*8(a-h,o-z)
      PARAMETER(IMP=2, ERROR=1d-8, QMAX=5)
      REAL*8 INTT,INTP,KP,LOGD,LM
	real*8 LT
      INTEGER BC,COUNT,CC,CCP,PCON,SCON
      LOGICAL L1,L4
      DIMENSION Y(NMAX+1),W(NMAX+1),Z(NMAX+1)
      NMAXP=NMAX+1
      NMAXP=NMAX
      IFAULT = 0
      CONV=1./H2SM
      HP=H*H
      LM=(LT+1)*LT
      Y(1)=1.
      Y(1)=H**LT
      NT=-1
      COUNT=1
      RATIO=1.
      CCP=1
      BC=0
      NLAST = 0
      PPI = 1.0
      G2=0.0
      L1=SCON.EQ.1
      L4=SCON.EQ.2
      IF(L1) PPP=U
      IF(L4) PPP=EIG
      P=PPP
      PP=PPP
      IF(PCON.GE.3)WRITE(IMP,207) NODES
  207 FORMAT(/'    PARAMETERS      MISMATCH    NODES  =>',i4)
  102 KP=-EIG/H2SM
C                 Use logarithmic derivative BETA at Rmax   G3=E-V
	Y(NMAXP)= 1d-50
	Y(NMAXP-1)=Y(NMAXP) *(1d0 - BETA * H)
      G3=-LM/(NMAX*NMAX*HP)-(W(NMAX)*U+Z(NMAX)+KP)
C			use local energy approximation
	IF(G3.lt.-0.001) then
	    X = sqrt(-G3)
	    T = (X-BETA)/(2d0*X)
	    TP= 1d0 - T	    
	    Y(NMAXP-1)=Y(NMAXP) *(T*exp(X*H) + TP*exp(-X*H)
     X                             -H**3/6d0*LM*2d0/(NMAX*H)**2)
	    T=(Y(NMAXP)-Y(NMAXP-1))/(H*Y(NMAXP))
	else IF(G3.gt.0.001) then
	    X = sqrt(G3)
	    T = BETA/X
	    TP= 1d0 	    
	    Y(NMAXP-1)=Y(NMAXP) *(T*sin(-X*H) + TP*cos(-X*H))
c     X                             -H**3/6d0*LM*2d0/(NMAX*H)**2)
	    T=(Y(NMAXP)-Y(NMAXP-1))/(H*Y(NMAXP))
	endif
  103 DEL=0.
      NS=NMAXP-1
      INTT=0.
      INTP=0.
      Y(1)=Y(1)*RATIO
      RATIO=1.
      NCO=1
C		Find matching point: first allowed (E>V) as integrating in
C		NOT(?) first attractive turning point as integrate in.
C		If no such point found, use NMAX*2/3 (for positive EIG),
C		 and NMAX/10 for negative EIG.
c     NU=0
      DO 30 N=NS-10,NCMIN,-1
       NU = N
      G3=-LM/(N*N)-(W(N)*U+Z(N)+KP)*HP
   30   IF (G3.gt.0) go to 301
       if(EIG.ge.0) NU = NMAX*2/3
       if(EIG.lt.0) NU = NMAX/10
  301 T=0.
      TP=0.
      G3=-LM/(NMAXP*NMAXP)-(W(NMAXP)*U+Z(NMAXP)+KP)*HP+12.
      N=NS
   31 G1=G2
      G2=Y(N-NT)*G3
      G3=-LM/(N*N)-(W(N)*U+Z(N)+KP)*HP
c     IF(NU.eq.0) THEN
c       IF ((G3.GE.0.OR. N.LT.NUMIN).and.N.LT.NMAX/2)NU=N
c      ENDIF
      G3=G3+12.
      IF(N.EQ.1.AND.LT.EQ.1)G2=-2*Y(1)
      I=N-NT
      IF(N.NE.NS) Y(N)=((16.*Y(I)-G2)*9.0-G2-G1)/G3
      X=Y(N)**2
       IF(L1) DV=W(N)
       IF(L4) DV=-CONV
      T=T+X*DV
      TP=X+TP
      IF(Y(N)*Y(I).LT.0.0 .AND. N.gt.NCMIN.and.N.lt.NCMAX)NCO=NCO+1
      IF(N.EQ.NU)GO TO 41
      N=N+NT
      GO TO 31
   41 TP=TP-0.5*X
      ICC=NU-NT
      N=ICC-NT
      NS=N-NT
      LTT=NS-NT
      I=LTT-NT
      IFA=I-NT
      LOGD=147.0*Y(NU)-360.0*Y(ICC)+450.0*Y(N)
     1 -400.0*Y(NS)+225.0*Y(LTT)-72.*Y(I)+10.*Y(IFA)
      LOGD=NT*LOGD/(60.0*Y(NU)*H)
      NT=-NT
      NS=1
      DEL=-LOGD-DEL
      RATIO=1.0/(RATIO*Y(NU))
      INTT=T/X+INTT
      INTP=TP/X+INTP
      IF(NT.LE.0) GO TO 3
      X=Y(1)**2
       IF(L1) DV=W(1)
       IF(L4) DV=-CONV
      T=X*DV
      TP=X
      N=2
      G2=0
      IF(LT.EQ.1)G2=-2*Y(1)
      G3=-LM-(W(1)*U+Z(1)+KP)*HP+12.
      GO TO 31
    3 COUNT=COUNT+1
      IF(ABS(INTT).gt.1d300) go to 200
      INTP=INTP*X*RATIO*RATIO
      IFAULT=0
      IF(COUNT.GT.80)GO TO 200
      IF(PCON. GE.3) WRITE(IMP,217)P,DEL,NCO,NU
C  217 FORMAT(E14.6,E15.3,I6)
  217 FORMAT(F14.6,G15.6,I6,I4)
      IF(NCO.NE.NODES) GO TO 6
      Q=DEL/(INTT*H)
      IF(COUNT.GT.50.and.ABS(Q).lt.1e-3 )GO TO 7
      IF(ABS(DEL).LT.ERROR)GO TO 7
      IF(ABS(P).GT.ERROR) then
	if(ABS(Q/P).lt.ERROR)GO TO 7
	endif
      if(abs(Q).gt.QMAX) Q = SIGN(QMAX,Q)
   50 P = P+Q
      BC=1
      Q=2*Q
   51 NLAST = NCO
   52 IF(L1) THEN
       U = P
c      GO TO 103
       GO TO 102
      ELSE
       EIG=P
       GO TO 102
      ENDIF
    6 IF(BC.NE.0)GO TO 61
      IF(NLAST.ne.0.and.(NCO-NODES)*(NLAST-NODES).lt.0)GO TO 61
      CC=1
      IF(NCO.ge.NODES)CC=-1
 
c     IF(L4) CC=-CC
c     IF(CC.LT.0)CCP=-IABS(CCP)
c     IF(CCP.GT.0)PP=P
c     IF(CCP.LT.0)PP=0.5*PP
      PPI=PPI*1.5
      Q=PPI*CC
      P = P+Q
      Q=2*Q
      GO TO 51
   61 Q=0.5*Q
      P=P-0.5*Q
      GO TO 52
    7 INTP=INTP*H
      INTP=SQRT(1d0/INTP)
 
      Q = 0d0
      G = 4d0/3d0
      DO 8 N=1,NMAX
      X=N*H
      T=1.d0
      IF(N.LE.NU)T=RATIO
      Y(N)=Y(N)*INTP*T
c	write(4,*)  N,Y(N),T,INTP
C   ------------------- Scale by 1/r if required:
C      Y(N)=Y(N)/X
	if(N.eq.NMAX) G=1d0/3d0
      Q = Q + H*G*Y(N)**2
	G=2d0-G
    8 CONTINUE
	Q = sqrt(1d0/Q)
	do 9 N=1,NMAX
    9   Y(N)=Y(N)*Q

C      IF(SCON.LT.10)WRITE(IMP,991)PP,P
      IF(PCON.gt.0)WRITE(IMP,991)P,COUNT,BETA
C 991 FORMAT(///' EIG ',12H VARIED FROM,F9.5,4H TO ,F9.5)
  991 FORMAT(' BOUND STATE AT',G10.3,' (AFTER',I3,' ITERATIONS)',
     X  ', BETA =',F8.3)
      IF(PCON.lt.0.or.MOD(PCON,2).EQ.0)RETURN
      WRITE(IMP,992)
  992 FORMAT(//20H   N     R      Y(R))
      WRITE(IMP,998)(N,N*H,Y(N),N=10,NMAX,10)
  998 FORMAT(4(I4,F8.3,2X,E11.4,3X))
      RETURN
  200 IFAULT = 1
      WRITE(IMP,986) IFAULT
  986 FORMAT(32H PROGRAM FAILURE- ROUTINE SEARCH,I5)
      WRITE(IMP,992)
      do 987 N=1,NMAX
  987 WRITE(IMP,*) N*real(H),Y(N)
C     IFAULT=IFAULT/0
C     STOP
      RETURN
      END
