      SUBROUTINE TMAT (KMAT,TRMAT,TIMAT,PRTM,IOP,NOP,
     X                  NFTT,NOPD,FAD,CTN,DTN,NB,KFAD,STIL,NCOL,LCHL,
     X                  LXTR,fadex,MCHAN3)
	use globals, only: nbody,mintl,initl,ecores,phtlast,phtadd,mass
      IMPLICIT INTEGER (A-Z)
      REAL*8 KMAT,TRMAT,TIMAT,A,B,ZERO,ONE,TWO,WND,PH,ADD,PREV,PI,CTN
     x		,DTN,PHI,PHTOT
      REAL*8 EE,FLOSS,ETAS,X1,JTOT,REAC,DELTA,ELAST,SEIG(NOPD,2),
     X		T,wvk0,wvk,vfac(MCHAN3,MCHAN3),EEL
      COMPLEX*16 SBII,SIJ,SKL,STIL(NB,NB),SMATSY(MCHAN3,MCHAN3)
      COMMON /IE/ EE,IERR
      LOGICAL PRTM,FAD
      PARAMETER ( ZERO=0.0D0,ONE=1.D0,TWO=2.D0 )
      DIMENSION KMAT(MCHAN3,MCHAN3),TRMAT(*),TIMAT(*),
     X	  A(NOPD,NOPD),B(NOPD,NOPD),
     X    CTN(MCHAN3,MCHAN3),DTN(MCHAN3,MCHAN3),
     X    IPVT(NOPD),LCHL(*),LXTR(6,*),KFAD(*),IOP(*),PH(NOP)
      COMMON /IO/ IIN,IOUT
      integer PARITY,fadex
      common /ccset/ JTOT,PARITY
      real*8 scent,ryev,xk
      common /cent/ scent,ryev
      CHARACTER PSIGN(3),FADS(4),CH
      DATA PSIGN / '-','?','+' /, FADS / 'T','Y','X','M' /, ELAST /0.0/
      SAVE ELAST
	PI = 4d0*ATAN(ONE)
        write(271,*) EE,mass
*
*     TMAT : T-matrix computed from K-matrix
*            S = ( 1 + I * K ) / ( 1 - I * K ) ;  S = DEL + T
*            T = 2 * I * K / ( 1 - I * K )
*
      NOP2 = NOP * NOP
      IF ( NOP .EQ. 1 ) THEN
         A(1,1) = KMAT(1,1)**2
         B(1,1) = ONE / ( ONE + A(1,1) )
         TIMAT(1) = TWO * KMAT(1,1) * B(1,1)
         TRMAT(1) = -TWO * A(1,1) * B(1,1)           
      ELSE
C
C  Solve T = (1 - i K)^-1 * 2i K   
C  by    (1-i K) * (Tr + iTI) = 2i K
C   or
C       (  1   K )  (TR)    (  0  )
C       (        )  (  )  = (     )
C       ( -K   1 )  (TI)    ( 2*K )  where A = N^-1 K
C
         DO 10 I = 1, NOP
         DO 10 J = 1, NOP
	     A(I,J) = 0.0
	     if(IOP(I).eq.IOP(J)) A(I,J) = 1.0
	  A(I+NOP,J+NOP) = A(I,J)
	  A(I,J+NOP) = KMAT(I,J)
	  A(I+NOP,J) = -KMAT(I,J)
	  B(I,J) = 0.0
	  B(I+NOP,J) = TWO * KMAT(I,J)
10	CONTINUE

c   A =P*L*U factorisation:
         CALL DGETRF (NOPD,NOPD,A,NOPD,IPVT,IER)
         IF ( IER .lt. 0 ) THEN
            WRITE (IOUT,1000) IER
            STOP
         ELSE IF ( IER .gt. 0 ) THEN
            WRITE (IOUT,1001) IER
	    A(IER,IER) = ONE
         ENDIF

C   Solve A*(TRMAT,TIMAT) = B
         CALL DGETRS('N',NOPD,NOP,A,NOPD,IPVT,B,NOPD,IER)
         IF ( IER .NE. 0 ) THEN
            WRITE (IOUT,1010) IER
            STOP
         ENDIF
      DO 30 I = 1, NOP
      DO 30 J = 1, NOP
	II = NOP * (J-1) + I
         TRMAT(II) = B(I,J)
         TIMAT(II) = B(I+NOP,J)
   30 CONTINUE
      ENDIF
      IF (PRTM) THEN
c        WRITE (IOUT,1020)
c        CALL WRTMAT (TRMAT,NOP,NOP,NOP,NCOL)
c        WRITE (IOUT,1030)
c        CALL WRTMAT (TIMAT,NOP,NOP,NOP,NCOL)
      ENDIF
*
*  Convert T to S matrix in-situ
         DO 40 I = 1, NOP
            II = NOP * ( I - 1 ) + I
            TRMAT(II) = TRMAT(II) + ONE
   40    CONTINUE
C
      IF (PRTM.and.NOP>1) THEN
C         WRITE (IOUT,1021)
C         CALL WRTMAT (TRMAT,NOP,NOP,NOP,NCOL)
C         WRITE (IOUT,1031)
C         CALL WRTMAT (TIMAT,NOP,NOP,NOP,NCOL)
	write(IOUT,*) ' S matrix,real:'
	DO 55 I=1,NOP
   55   write(IOUT,56) I,(TRMAT(NOP*(J-1)+I),J=1,NOP)
	write(IOUT,*) ' S matrix,imag:'
	DO 555 I=1,NOP
  555   write(IOUT,56) I,(TIMAT(NOP*(J-1)+I),J=1,NOP)
	write(IOUT,*) ' S matrix, symmetrised:'
	do 558 I=1,NOP
	    wvk = sqrt(abs(EE - ecores(iop(I)))/ryev)
	do 557 J=1,NOP
	    wvk0 = sqrt(abs(EE - ecores(iop(J)))/ryev)
	 vfac(I,J) = sqrt(wvk/wvk0)
            IJ = NOP * ( J - 1 ) + I
 557	SMATSY(I,J) = dcmplx(TRMAT(IJ),TIMAT(IJ)) *vfac(I,J)
  558   write(IOUT,56) I,(SMATSY(I,J),J=1,NOP)
   56   format(1x,I3,18f7.3,:,/(4x,18f7.3))
	write(IOUT,*) ' Core energies'
        write(IOUT,56) 0,(ecores(iop(J)),J=1,NOP)
	write(IOUT,*) ' Wave numbers '
        write(IOUT,56) 0,(sqrt(abs(EE - ecores(iop(J)))/ryev),J=1,NOP)
	write(IOUT,*) ' Velocity factors '
	do 561 I=1,NOP
  561   write(IOUT,56) I,(vfac(I,J),J=1,NOP)
      ENDIF
C   ####  TRANSFORM TO ORTHONORMAL TN STATES   ################
	if(fadex.eq.1) then
	  do 60 k=1,NB
	  do 60 l=1,NB
            kl = k + NOP * ( l - 1 )
60	   STIL(k,l) = cmplx(trmat(kl),timat(kl))
	else
c       if (PRTM) call printm ('CTN ',CTN,NB,NOP,MCHAN3)
c       if (PRTM) call printm ('DTN ',DTN,NOP,NB,MCHAN3)

c		Construct STIL as the new unitary S-matrix:
	  do 65 i=1,NB
	  do 65 j=1,NB
	  SIJ = ZERO
	  do 64 k=1,NOP
	  do 64 l=1,NOP
            kl = k + NOP * ( l - 1 ) 
      	    SKL=cmplx(trmat(kl),timat(kl))
64	  SIJ = SIJ + DTN(i,k) * SKL * CTN(l,j)
65	  STIL(i,j) = SIJ
      if(PRTM) then
	write(IOUT,*) ' S-tilde matrix, real:'
	DO 67 I=1,NB
   67   write(IOUT,56) I,(real(STIL(I,J)),J=1,NB)
	write(IOUT,*) ' S-tilde matrix, imag:'
	DO 68 I=1,NB
   68   write(IOUT,56) I,(aimag(STIL(I,J)),J=1,NB)
	endif
      endif

C   ####  PARTIAL AMPLITUDES   ################
C
!	write(6,*) 'TMAT: NB,NOP,IOP(*) ',NB,NOP,(IOP(i),i=1,NOP)
!      do 140 nc = 1, NB
      do 140 nc = 1, NOP
	kf = KFAD(iop(nc))
	CH = FADS(kf)
	if(kf.gt.1) CH=FADS(4)
            II = NOP * ( nc - 1 ) + nc
      SBII=STIL(nc,nc) 
      WND = ONE
      REAC = WND - conjg(SBII)*SBII
      ETAS=ABS(SBII) 
c      ETAS=sqrt(ONE-REAC)
      FLOSS = WND 
	wvk0 = sqrt(abs(EE - ecores(iop(nc)))/ryev)
      DO 135 mc=1,NOP
            IJ = NOP * ( nc - 1 ) + mc
            X1 =conjg(STIL(mc,nc))*STIL(mc,nc) 
	    wvk = sqrt(abs(EE - ecores(iop(mc)))/ryev)
      FLOSS = FLOSS - X1 * wvk/wvk0
 135  CONTINUE
      SKL   =180d0/PI*.5*(-(0.,1.)*LOG(SBII))
      PH(nc)=SKL
      PHI = aimag(SKL)
C     IF(PH(nc).LT.0.0) PH(nc) = 180. + PH(nc)
      if(abs(FLOSS).ge.1e-20) FLOSS = log10(abs(FLOSS))

      IJP = nint(2*JTOT)
      IF(abs(JTOT-nint(JTOT)).lt.0.1) IJP = nint(JTOT)
      if(nbody==3) then
      WRITE(IOUT,1015) EE,IJP,PSIGN(PARITY+2),CH,IOP(nc),
     X                 LCHL(IOP(nc)),LXTR(3,IOP(nc)),LXTR(4,IOP(nc)),
     X                 PH(nc),ETAS,REAC
     X			 ,FLOSS
	else
	if(IOP(nc).le.mintl) then
          WRITE(IOUT,1016) EE,JTOT,PSIGN(PARITY+2),IOP(nc),
     X             mod(LCHL(IOP(nc)),100),PH(nc),PHI,ETAS,REAC,FLOSS
	  do mc=1,NOP
	  write(IOUT,1017)  IOP(mc),LCHL(IOP(mc)),STIL(mc,nc)*
     X	   (0d0,1d0)**(LCHL(IOP(nc))-LCHL(IOP(mc))),abs(STIL(mc,nc))**2
	  enddo
	  else
          WRITE(IOUT,1018) EE,JTOT,PSIGN(PARITY+2),IOP(nc),
     X             mod(LCHL(IOP(nc)),100),PH(nc),PHI,ETAS,REAC,FLOSS
	  endif
	endif

 1015 FORMAT( ' E',F7.3,',',I2,A1,' ',A1,I3,' Kll ',3I2,': D',F7.2,
     X        ' d, |S|',F8.4,', R',F8.4,:,' A',F7.2)
c    X        ' d, |S|',F8.4,', R',F8.4)
 1016 FORMAT( ' E',F8.3,',',f7.1,A1,' ',I3,' L ',I2,':',
     X        ' elastic ',2F7.2,' d, |S|',F8.4,', R',F8.4,:,' A',F6.2)
 1017 FORMAT( '   S-matrix element:',I3,' L ',I4,':',2f10.5,'i,',
     X			'  modsq=',F9.6)
 1018 FORMAT( ' E',F8.3,',',f7.1,A1,' ',I3,' L ',I2,':',
     X        '         ',2F7.2,' d, |S|',F8.4,', R',F8.4,:,' A',F6.2)
 1022 FORMAT(F10.1,2F12.8,'i: elastic S-matrix ')
C  ******
  140 continue
       if(mintl>0) write(IOUT,1022) JTOT,STIL(IOP(1),IOP(1))
        EEL = EE*(mass(1)+mass(2))/mass(2)

	if(EE.lt.ELAST) write(27,*) '&   Now for J,pi=',real(JTOT),
     X			PSIGN(PARITY+2)
	if(EE.lt.ELAST) write(128,*) '&   Now for J,pi=',real(JTOT),
     X			PSIGN(PARITY+2)
	write(27,72) EE,(PH(I),I=1,min(NOP,18))
     x                 ,(0.   ,I=  min(NOP,18)+1,min(MCHAN3,18))
	write(270,72) EEL,(PH(I),I=1,min(NOP,18))
     x                 ,(0.   ,I=  min(NOP,18)+1,min(MCHAN3,18))
	XK = sqrt(EE/ryev)
c	write(127,172) XK,(PH(I),I=1,min(NOP,10))
 	write(128,172) XK,(tan(PI*PH(I)/180.)/XK,I=1,min(NOP,10))
!	call flush(27)
!	call flush(128)
172     format(F10.7,10F11.6)
c173    format(F10.6,10F10.4)
c
c			Calculate eigenphases of S-matrix
	do 69 I=1,NOP
	    wvk = sqrt(abs(EE - ecores(iop(I)))/ryev)
	do 69 J=1,NOP
	    wvk0 = sqrt(abs(EE - ecores(iop(J)))/ryev)
	 vfac(I,J) = sqrt(wvk/wvk0)
            IJ = NOP * ( J - 1 ) + I
	A(I,J) = TRMAT(IJ) * vfac(I,J)
 69 	B(I,J) = TIMAT(IJ) * vfac(I,J)
      call f02ajf(A,NOPD,B,NOPD,NOP,SEIG(1,1),SEIG(1,2),IPVT,ifail)
	PHTOT = 0.
	do 70 I=1,NOP
      	PH(I)=180d0/PI*.5*atan2(SEIG(I,2),SEIG(I,1))
 	PHTOT  = PHTOT + PH(I)
 70	continue
        if(PHTOT>phtlast + 90.) phtadd = phtadd - 180.
        if(PHTOT<phtlast - 90.) phtadd = phtadd + 180.
	write(IOUT,71) EE,JTOT,PSIGN(PARITY+2),(PH(I),I=1,NOP)
 71 	FORMAT(/' S eigenphases at E',F8.3,',',F5.1,A1,' :',/,(10f8.3))
c	write(IOUT,*) ' with moduli:'
c	write(IOUT,715) (SEIG(I,1)**2+SEIG(I,2)**2,I=1,NOP)
 715	FORMAT(10f8.4)
	if(EE.lt.ELAST) write(29,*) '&   for J,pi=',real(JTOT),
     X			PSIGN(PARITY+2)
	write(29,72) EE,PHTOT+phtadd,(PH(I),I=1,min(NOP,18))
     x                 ,(0.   ,I=  min(NOP,18)+1,min(MCHAN3,18))
 72     format(F9.6,f10.3,3F8.3,15F7.2)
	ELAST = EE
	phtlast = PHTOT
      IF (NFTT .GT. 0) WRITE (NFTT) EE,NOP,NOP,(TRMAT(I),
     X                              TIMAT(I),I=1,NOP2)
      RETURN
*
 1000 FORMAT (' TMAT : Error return from DGETRF, IER =',I6)
 1001 FORMAT (' TMAT, DGETRF: N-iK matrix singular after ',I6)
 1010 FORMAT (' TMAT : Error return from DGETRS, IER =',I6)
 1020 FORMAT (' REAL PART OF T - MATRIX :')
 1030 FORMAT (' IMAG PART OF T - MATRIX :')
 1021 FORMAT (' REAL PART OF S - MATRIX :')
 1031 FORMAT (' IMAG PART OF S - MATRIX :')
      END
