      implicit real*8(a-h,o-z)
      parameter(nchan=1)
      integer lchl(nchan,5),ichl(nchan)
      real*8 vk(500)
      real scent,A1,A2,Z1,Z2,RCORE,ROIN,ROSTEP

      A1 = 1.0
      A2 = 10.0
      Z1 = 0.0
      Z2 = 4.0
      RCORE = 2.30
      roin = 0.2
      rostep = 0.2
      nrooo = 70
      rinner = roin+rostep*(nrooo-1)
      scent = 0.0
      h2sm = 20.748
      ryev =h2sm*(A2+A1)/A2
      ichl(1) = 1
      open(21,file='vset3.spec',form='formatted')
      open(20,file='vset3.mel',form='unformatted')

      write(21,*) 'Woods-Saxon single-channel potential'
      write(21,*) ryev,1.4398523
      write(21,102) (real(ROIN),real(ROSTEP),NROOO,i=1,2),rinner
102     format(2f8.4,I5,2f8.4,I5,f10.5)
      write(21,*) 2,scent,4,2,0,1,.true.,.true.,1,1,0
	write(21,'(''  L Ip  J It JT'')')
* multipliers, jgt
	write(21,'(''  1  2  2  2  2  5'')')
* 4 coupling orders
	write(21,'(''  1  2  3  3  4  5'')')
	write(21,*) A1,A2,Z1,Z2,0,RCORE

        write(21,1045) 'Nucleon',1,0.,0.,0., 0.,1
        write(21,1045) 'Core',1,0.,0.,0., 0.,1
1045      format(a8,i3,f4.1,2f10.4,10(f8.4,i4))
	write(21,1046) .false.,0.
1046 	  format(3(L2,f4.1))
!      write(21,*) 1,0.0,+1,0.0,0.0
      write(6,*) ' Enter number of sets:'
      read(5,*) nsets
      do 100 iset=1,nsets
      write(6,*) ' Enter l & V,R,a of WS potential for set',iset,':'
      read(5,*) lchl(1,iset),V,R,a
      jj2 = 2*lchl(1,iset)
      npar = (-1)**lchl(1,iset)
      write(21,*) ' J,pi=',real(jj2*0.5),npar
      write(21,106) jj2,npar,nchan,0,0.0,0,0
106       format(4i5,f10.5,g12.4)
      write(21,*) (1,i=1,nchan)
      write(21,*) (1,i=1,nchan)
!      write(21,*) (1,i=1,nchan)
      write(21,*) (lchl(i,iset),i=1,nchan)
      write(21,*) (0,i=1,nchan)
      write(21,*) (2*lchl(i,iset),i=1,nchan)
      write(21,*) (0,i=1,nchan)
      write(21,*) (2*lchl(i,iset),i=1,nchan)
      write(21,*) 0,0
      do  10 ir=1,nrooo
      rad = (ir-1)*rostep + roin
10    vk(ir)  = V/(1.+exp((rad-R)/a)) 
      write(20) (vk(ir),ir=1,nrooo)
100   continue
      stop
      end
