      SUBROUTINE ASYMB (E,NC,LCHL,CF,MCHAN,BBLOCH,F,FP,ET,LMAX,
     X                  NOP,RAFIN,RMATCH,PRWR,PRWF,ERRMAX,
     X                  APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X                  PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                  LWSECT,NMATCH,NFINAL,WFIN,LWGF,WFNR,NR)
      IMPLICIT INTEGER (A-Z)
      DOUBLE PRECISION E,CF,BBLOCH,F,FP,ET,EWRON,APEPS,DEGENY,RAFIN,
     X                 RMATCH,GMAX,DEPLIM,ERRMAX(2),R,ELX,LWSECT,WFNR,AE
      LOGICAL PROP,DEBUG,PRWF,PRWR,WFIN
      CHARACTER*6 CRAD
      PARAMETER (NCRIT=4)
      DIMENSION LCHL(NC),CF(MCHAN,MCHAN,NUMAX),APFLG(5),
     X          F(NC,NC,2),FP(NC,NC,2),ET(NC),LWKEEP(LWRAN),KEEP(LWRAN),
     X          CRAD(2),LWSECT(LWRAN),LWGF(LWRAN),WFNR(MCHAN,MCHAN,NR+1)
      COMMON /IO/ IIN,IOUT
      real*8 scent,ryev,vval
      common /cent/ scent,ryev
      DATA CRAD/'RAFIN','RMATCH'/
*
*     calculate wave functions (all channels closed)
*
c      prwr = .false.
c      prwf = .false.
c       apflg(1) = 0
      IF (NOP .NE. 0) THEN
         WRITE (IOUT,1020) NOP
         STOP
      ENDIF
      CALL GAILCO (NC,APFLG,ET,LCHL,CF,MCHAN,NUMAX,IASY,DEGENY,GMAX)
      CALL GAILIT (F,FP,NC,NC,APFLG,RAFIN,ET,LCHL,IASY,
     X			APEPS,LMAX,AE)
c     CALL WRONSK (NC,NOP,F,FP,1,PRWR,EWRON,E,ERRMAX(1))
      CALL WRONSK2(NC,NOP,F,FP,1,ET,ERRMAX(1))
      IF (PRWF) THEN
         WRITE (IOUT,1000) CRAD(1),RAFIN
         CALL WRTMAT (F,NC,NC,NC,NCOL)
c         WRITE (IOUT,1010) CRAD(1),RAFIN
c         CALL WRTMAT (FP,NC,NC,NC,NCOL)
      ENDIF
      IF (PROP) THEN
         DO 30  J = NMATCH, NFINAL
	 R = LWSECT(J)
         NKEEP = NC
	 IF(DEPLIM.gt.1e-5) THEN
         DO 10  I = NOP + 1, NC
	 elx = (lchl(i) + scent) * ( lchl(i) + 1 + scent)/(R*R)
            IF (ET(I)-elx.LT. -DEPLIM) THEN
               NKEEP = I - 1
               GO TO 20
            END IF
   10    CONTINUE
	 ENDIF
   20    CONTINUE
c        NKEEP = MIN(NKEEP + NCRIT, NC)
c           KEEP(J) = MAX(LWKEEP(J), NKEEP)
c           KEEP(J) = MAX(NCRIT, MIN(LWKEEP(J), NKEEP))
	 IF(J.GE.NMATCH+2) KEEP(J) = MAX(KEEP(J),KEEP(J-2)-1)
	 KEEP(J) = MAX(NKEEP  ,NCRIT,MIN(NC,NC-(J-NMATCH-1)))
c            KEEP(J) = NC
   30    CONTINUE
	 CALL KLIST('ASYMB ',NMATCH,NFINAL,KEEP,NC)
         NSTP = NFINAL
         CALL LWFPRP (KEEP,NSTP,NMATCH,NC,E,DEBUG,RMATCH,IDISCR,F,FP,ET,
     X                NOP,LCHL,WFIN,LWGF,WFNR,MCHAN,NR)

c        CALL WRONSK (NC,NOP,F,FP,1,PRWR,EWRON,E,ERRMAX(2))
         CALL WRONSK2(NC,NOP,F,FP,1,ET,ERRMAX(2))
      ENDIF
      IF (PRWF) THEN
         WRITE (IOUT,1000) CRAD(2),RMATCH
         CALL WRTMAT (F,NC,NC,NC,NCOL)
c         WRITE (IOUT,1010) CRAD(2),RMATCH
c         CALL WRTMAT (FP,NC,NC,NC,NCOL)
      ENDIF
      RETURN
*
 1000 FORMAT (' SOLUTIONS AT ',A6,' =',F8.3)
 1010 FORMAT (' DERIVATIVES AT ',A6,' =',F8.3)
 1020 FORMAT (' ASYMB: ALL CHANNELS NOT CLOSED, NOP =',I4)
      END

      subroutine KLIST(who,m,n,keep,nc)
      integer keep(n),DONE
      character*6 who
      COMMON /IO/ IIN,IOUT
      save DONE
      data DONE /0/
      if (DONE.gt.2) return
      do 10 i=m,n
      if(keep(i).ne.nc) go to 20
10    continue
      i=n
20    m1 = i
      do 30 i=n,m1,-1
      if(keep(i).ne.nc) go to 40
30    continue
      i=m1-1
40    m2 = i
      if(m2.le.m1) return
      write(IOUT,50) who,m,n,nc,m1,m2
50    format(1x,A6,': keep[',2i4,'] ne',i3,' from ',i3,' to ',i3,'::')
      write(3,50) who,m,n,nc,m1,m2
      if(DONE.eq.0) write(IOUT,60) (keep(i),i=m1,m2)
      write(3,60) (keep(i),i=m1,m2)
60    format(1x,20i3)
      DONE=DONE+1
      return
      end
      SUBROUTINE ASYMO (E,RMAT,KM,KMAT,NC,LCHL,CF,MCHAN,BBLOCH,F,FP,ET,
     X           LMAX, NOP,RMATR,RAFIN,PRRM,PRWR,PRWF,PRKM,ERRMAX,
     X                 APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X                 PROPO,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                 LWSECT,NMATR,NFINAL,WFIN,LWGF,
     x		       WFN,MNOP,NR,MCHAN3,RSTEP,SRMAT,SIMAT)
      IMPLICIT INTEGER (A-Z)
      REAL*8 E,RMAT,KMAT,CF,BBLOCH,F,FP,ET,EWRON,APEPS,DEGENY,RAFIN,
     X       RMATR,GMAX,DEPLIM,ERRMAX,LWSECT,elx,R,scent,ryev,AM,ff,RR,
     X	     SRMAT,SIMAT,EE
      COMPLEX*16 WFN
      REAL*8 ONE,ABL,DEL,RSTEP
      LOGICAL PROPO,DEBUG,PRRM,PRWF,PRWR,PRKM,KM,WFIN
      PARAMETER (NCRIT=4, ONE=1D0)
      DIMENSION LCHL(NC),CF(MCHAN,MCHAN,NUMAX),RMAT(nc*nc),KMAT(nc*nc),
     X          APFLG(5),F(NC,NC,4),FP(NC,NC,4),ET(NC),
     X          LWKEEP(LWRAN),KEEP(LWRAN),LWSECT(LWRAN),LWGF(LWRAN),
     X		SRMAT(NOP,NOP),SIMAT(NOP,NOP)
      DIMENSION WFN(MNOP,MCHAN3,NR+1)
      COMMON /IO/ IIN,IOUT
      common /cent/ scent,ryev
      COMMON /IE/ EE,IERR
      CHARACTER*4 REIM(2)
      DATA REIM / 'Real','Imag' /
c       ABL(R) = LOG10(MAX(ABS(R),1D-30))
*
*     propagate regular wfn in to RMATR , with help of RMAT there
*
*	First find complex regular solution F  <- (H(-) - H(+).S)
*	                                    FP <- (H'(-) - H'(+).S)
*			where H(+) = G + i.F
*			           = F(**,2) + i.F(**,1) etc for H',H(-)
*	That is find real and imaginary parts:
* 	F (**,3) = G - G.SR + F.SI    = F(*2) - F(*2).SR + F(*1).SI
* 	F (**,4) = -F - F.SR - G.SI   = -F(*1) - F(*1).SR - F(*2).SI
*	FP(**,3) = G' - G'.SR + F'.SI = FP(*2) - FP(*2).SR + FP(*1).SI
* 	FP(**,4) = -F'- F'.SR - G'.SI = -FP(*1)-FP(*1).SR - FP(*2).SI
*     (Then move back to F/FP(**,1 & 2)

*  F (**,3) 
      call dcopy(NC*NC,F( 1,1,2),1,F(1,1,3),1)
      call dgemm ('n','n',NC,NOP,NOP,-ONE,F(1,1,2),NC,SRMAT,NOP,
     X			ONE,F(1,1,3),NC)
      call dgemm ('n','n',NC,NOP,NOP,+ONE,F(1,1,1),NC,SIMAT,NOP,
     X			ONE,F(1,1,3),NC)

*  FP(**,3) 
      call dcopy(NC*NC,FP( 1,1,2),1,FP(1,1,3),1)
      call dgemm ('n','n',NC,NOP,NOP,-ONE,FP(1,1,2),NC,SRMAT,NOP,
     X			ONE,FP(1,1,3),NC)
      call dgemm ('n','n',NC,NOP,NOP,+ONE,FP(1,1,1),NC,SIMAT,NOP,
     X			ONE,FP(1,1,3),NC)

* F (**,4) 
      call dcopy(NC*NC,F( 1,1,1),1,F(1,1,4),1)
      call dgemm ('n','n',NC,NOP,NOP,-ONE,F(1,1,1),NC,SRMAT,NOP,
     X			-ONE,F(1,1,4),NC)
      call dgemm ('n','n',NC,NOP,NOP,-ONE,F(1,1,2),NC,SIMAT,NOP,
     X			ONE,F(1,1,4),NC)

* FP(**,4)
      call dcopy(NC*NC,FP( 1,1,1),1,FP(1,1,4),1)
      call dgemm ('n','n',NC,NOP,NOP,-ONE,FP(1,1,1),NC,SRMAT,NOP,
     X			-ONE,FP(1,1,4),NC)
      call dgemm ('n','n',NC,NOP,NOP,-ONE,FP(1,1,2),NC,SIMAT,NOP,
     X			ONE,FP(1,1,4),NC)
* Now
*  copy back F(**,K+2) to F(**,K) etc
      call dcopy(NC*NC,F( 1,1,3),1,F(1,1,1),1)
      call dcopy(NC*NC,FP(1,1,3),1,FP(1,1,1),1)
      call dcopy(NC*NC,F (1,1,4),1,F(1,1,2),1)
      call dcopy(NC*NC,FP(1,1,4),1,FP(1,1,2),1)
c	write(75,40) ryev*E,(F(1,1,K),K=1,2),(FP(1,1,K),K=1,2)

      IF (PRWF) THEN
	write(6,*)
	   DO K=1,2
            WRITE (IOUT,1010) REIM(K),RAFIN
            CALL WRTMAT (F(1,1,K),NC,NOP,NC,NCOL)
c           WRITE (IOUT,1020) REIM(K),RAFIN
c           CALL WRTMAT (FP(1,1,K),NC,NOP,NC,NCOL)
	   ENDDO
      ENDIF
      IF (PROPO) THEN
	write(3,*) ' ASYMO: propagate in ',real(RAFIN),NFINAL,
     X			' to',real(RMATR),NMATR
         DO 30  J = NFINAL, NMATR, -1
         R = LWSECT(J)
	 IF(DEPLIM.gt.1e-5) THEN
c				Check the closed channels:
         DO 24  I = NOP + 1, NC
        elx = (lchl(i) + scent) * ( lchl(i) + 1 + scent)/(R*R)
            IF (ET(I)-elx.LT. -DEPLIM) THEN
c           IF (ET(I) .LT. -DEPLIM) THEN
               NKEEP = I - 1
               GO TO 25
            END IF
   24    CONTINUE
	 ENDIF
         NKEEP = NC
   25    NKEEP = MIN(NKEEP + NCRIT, NC)
*           KEEP(J) = MAX(LWKEEP(J), NKEEP)
*           KEEP(J) = MIN(LWKEEP(J), NKEEP)
            KEEP(J) = NC
   30    CONTINUE
	 CALL KLIST('ASYMO',NMATR,NFINAL,KEEP,NC)
	write(3,*) ' ASYMO: propagate in from',RAFIN,' to',RMATR
	
         CALL PROPOF(NC,NOP,NC,F,FP,RMATR,RMAT,IDISCR)

c	write(74,40) ryev*E,(F(1,1,K),K=1,2),(FP(1,1,K),K=1,2)
        IF (PRWF) THEN
	    write(6,*)
	   DO K=1,2
            WRITE (IOUT,1010) REIM(K),RMATR
            CALL WRTMAT (F(1,1,K),NC,NOP,NC,NCOL)
c           WRITE (IOUT,1020) REIM(K),RMATR
c           CALL WRTMAT (FP(1,1,K),NC,NOP,NC,NCOL)
	   ENDDO
        ENDIF
C			For historical reasons in BELMAG etc,
C			the fuh=WFN(M,I,IR) is for incoming wave in ch. M
	do 35 I=1,NC
	do 35 J=1,min(NC,MNOP,NOP)
	  WFN(J,I,1) = CMPLX(FP(I,J,1),FP(I,J,2))
   35	  WFN(J,I,2) = CMPLX(F (I,J,1),F (I,J,2))
        IF (PRWF) THEN
	write(105,40) RMATR,(F(I,I,1),I=1,min(NC,10,NOP))
	write(106,40) RMATR,(F(I,I,2),I=1,min(NC,10,NOP))
   40   format(f9.4,1p,10e10.2)
c	write(103,41) RMATR,(ABL(F(I,I,1)),I=1,min(NC,10,NOP))
c	write(104,41) RMATR,(ABL(F(I,I,2)),I=1,min(NC,10,NOP))
   41   format(f8.3,10f8.2)
	ENDIF

*		Now progagate this regular solution to the RMATR+i*rstep
 	if(WFIN) then
	rewind(IDISCR+1)
	IR = 3
	do 50 NSTEP = NMATR,NFINAL
	if(LWGF(NSTEP).gt.0) then
         CALL PROPWF (R,NC,NC,NOP,F,FP,IDISCR)
        IF (PRWF) THEN
C	All these wave functions should be at R=RR, to be consistent!
c	 RR = RMATR + (IR-2)*RSTEP
	 write(105,40) R,(F(I,I,3),I=1,min(NC,10,NOP))
	 write(106,40) R,(F(I,I,4),I=1,min(NC,10,NOP))
c	 write(103,41) R,(ABL(F(I,I,3)),I=1,min(NC,10,NOP))
c	 write(104,41) R,(ABL(F(I,I,4)),I=1,min(NC,10,NOP))
	ENDIF
	 do 45 I=1,NC
	 do 45 J=1,min(NC,MNOP,NOP)
   45	  WFN(J,I,IR) = CMPLX(F (I,J,3),F(I,J,4))
	 IR = IR+1
	endif
   50	continue
          IF (PRWF.and..false.) THEN
	   write(6,*) ' Wave function propagated back to RAFIN:'
	   DO K=1,2
            WRITE (IOUT,1010) REIM(K),RAFIN
            CALL WRTMAT (F(1,1,2+K),NC,NOP,NC,NCOL)
c           WRITE (IOUT,1020) REIM(K),RAFIN
c           CALL WRTMAT (FP(1,1,2+K),NC,NOP,NC,NCOL)
	   ENDDO
          ENDIF
	endif

      ENDIF
      RETURN
*
 1010 FORMAT (' REGULAR ',A4,' solutions at r =',F10.3)
 1020 FORMAT (' REGULAR ',A4,' derivatives at r =',F10.3)
      END

      SUBROUTINE ASYMS (E,RMAT,KM,KMAT,NC,LCHL,CF,MCHAN,BBLOCH,F,FP,ET,
     X            LMAX, IOP,NOP,RAFIN,RSTART,PRRM,PRWR,PRWF,PRKM,ERRMAX,
     X                 APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X                 PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                 LWSECT,NSTART,NFINAL,WFIN,LWGF,PPN,MCHAN3,
     X		       RMATO,RAFINI,radius,maxtry,rfact,rafix,gfact,
     X		       PRNTV,LDEBUG,BETA,CUPLIM,ETHR,FAD,NBLOCK,EFERMI)
      IMPLICIT INTEGER (A-Z)
      REAL*8 E,RMAT,KMAT,CF,BBLOCH,F,FP,ET,EWRON,APEPS,DEGENY,RAFIN,
     X       GMAX,DEPLIM,ERRMAX,LWSECT,RSTART,PPN,RMATO,BETA,CUPLIM,AE
      real*8 radius(maxtry),rfact,rafix,gfact,gmaxp,rafprev,raf,EFERMI,
     X  rafmax,rlwmax,rnorm,r1,r2,zero,threshr,EE,RAFINI,RDONE,ETHR,GBAR
      LOGICAL PROP,DEBUG,PRRM,PRWF,PRWR,PRKM,KM,WFIN,PRG,failw,failr,
     X		fail,failg,FAD,PRNTV,LDEBUG,rafold
      PARAMETER (NCRIT=4, zero=0d0, threshr=50d0)
      DIMENSION LCHL(NC),CF(MCHAN,MCHAN,NUMAX),RMAT(NC*NC),KMAT(NC*NC),
     X          APFLG(5),F(NC,NC,2),FP(NC,NC,2),ET(NC),PPN(*),ETHR(*),
     X          LWKEEP(LWRAN),KEEP(LWRAN),LWSECT(LWRAN),LWGF(LWRAN),
     X          RMATO(*),IOP(*),GBAR(NC,NC,4)
      COMMON /IO/ IIN,IOUT
      COMMON /IE/ EE,IERR
      COMMON /ccset/ jtot,npty
      real*8 scent,ryev,jtot
      common /cent/ scent,ryev
      CHARACTER FG(2)
      DATA FG / 'F','G'/, nopp,gmaxp /0,0./
      SAVE GMAX,gmaxp,rafprev,nopp
*
*     propagate R-matrix to RAFIN, find Gailitis expansions there, 
*     and calculate K-matrix
*
*
*   keep channels if less deeply bound than deplim
*   but keep at least ncrit channels
*   further keep at each propagation sector at least the number of
*   channels decided by the strength of the coupling in the LW
*   package
*
         DO 22  J = NSTART, NFINAL
	 IF(DEPLIM.gt.1e-5) THEN
         DO 10  I = NOP + 1, NC
            IF (ET(I) .LT. -DEPLIM) THEN
               NKEEP = I - 1
               GO TO 20
            END IF
   10    CONTINUE
	 ENDIF
         NKEEP = NC
   20    NKEEP = MIN(NKEEP + NCRIT, NC)
*           KEEP(J) = MAX(LWKEEP(J), NKEEP)
            KEEP(J) = MIN(LWKEEP(J), NKEEP)
            KEEP(J) = NC
   22    CONTINUE
	 CALL KLIST('ASYMS',NSTART,NFINAL,KEEP,NC)
         PRG = PRWF.and.PRRM
	 NDONE = NSTART
	
	 if(WFIN) REWIND (IDISCR+1)
*
*  calculate gailitis coefficients for all channels as these are
*  independent of radius
*
      CALL GAILCO (NC,APFLG,ET,LCHL,CF,MCHAN,NUMAX,IASY,DEGENY,GMAX)
	write(3,*) ' GAILCO: at EE=',real(EE),' gmax =',GMAX 
c    X	,' gmaxp =',gmaxp,real(gfact)
*
*  on the basis of the magnitude of the maximum coefficient decide
*  whether to use at least the final radius calculated for the previous
*  energy so long as a threshold has not been crossed
*
      raf = RAFINI
      rafold =  nop .eq. nopp  .and. gmax .ge. gmaxp * gfact 
      if ( rafold ) raf = max (raf,rafprev)
      if ( rafold ) write(3,*) 'Using previous',real(raf)
      if ( .not.rafold ) write(3,*) 'Starting again @',real(raf)
      RAFIN = raf
      rafmax = lwsect(NFINAL)
      rlwmax = rafix
      if (NFINAL .eq. lwran) rlwmax = lwsect(lwran)
*
*  redefine the trial radius to lie on a sector end & find isect
*
      call secend (RAFIN,isect,NFINAL,lwsect,lwran)
*
	write(3,*) ' ASYMS: propagate ',NC,' from',RSTART,NSTART,
     X			' at least to',raf,isect
*
*  try at successive radii until obtain converged wavefunctions
*
      do 60 itry = 1,maxtry
         ntry = itry
         raf = RAFIN
c        nc = keep(isect)
	 radius(itry) = RAFIN
         rnorm = zero
      IF (PROP) THEN
*
*  Find global R matrix propagatorfrom RSTART to present RAFIN
*
	RDONE = lwsect(NDONE)
	write(3,24) RDONE,NDONE,RAFIN,isect
24      format(' ASYMS: to find gbar from',f12.3,i5,' to',f12.3,i5)
*
         CALL LWFPRPO (NDONE,isect,NC,NC,E,DEBUG,PRG,IDISCR,GBAR,
     X			WFIN,LWGF)
	NDONE = isect
*
*  Apply to R matrix RMATO at RSTART to get RMAT at RAFIN
*
	CALL GPROPI(RMATO,RMAT,NC,GBAR,RSTART,RAFIN)
         rnorm = zero
	 r1 = RAFIN * sqrt(EE) * (LCHL(1)+scent+1.)
         do 25 i=1,NC
         do 25 j=1,NC
                ij = i + (j-1)*MCHAN3
c 25       rnorm = rnorm + abs(RMAT(ij)/(LCHL(min(i,j))+scent+1))
c	   rnorm = rnorm * RAFIN * sqrt(E) /NC**2
  25       rnorm = max(rnorm,abs(r1*RMAT(ij)/(LCHL(min(i,j))+scent+1)))
c        write(279,*) real(EE),rnorm
	failr = rnorm .gt. threshr .and. WFIN
c	if(failr) write(6,251) RAFIN,EE,rnorm,threshr
251      format(' FAILED R test at r=',f12.3,', E =',F8.4,
     X		' as',F10.1,' >',f8.1)
      ELSE
c		RMAT already equal to RMATO: no copy required.
	failr = .false.
      ENDIF

c     CALL GAILCO (NC,APFLG,ET,LCHL,CF,MCHAN,NUMAX,IASY,DEGENY,
c    x			GMAX)
      CALL GAILIT (F,FP,NC,NC,APFLG,RAFIN,ET,LCHL,IASY,APEPS,
     X			LMAX,AE)

	failg = AE .gt. APEPS
	failg = .false.
	if(failg) write(6,26) 'G',RAFIN,EE,AE,APEPS
	NP = min(NC,2)
	if(PRRM.or.PRWF) then
 	  write(44,*) ' F,G Wronskians at RAFIN =',real(RAFIN)
          CALL WRONSK (NC,NOP,F,FP,2,PRWR,EWRON,ET,ERRMAX)
	endif
        CALL WRONSK2 (NC,NOP,F,FP,2,ET,ERRMAX)
c	write(6,*) ' F,G Wronskians at RAFIN =',real(RAFIN),
c    x			' have max. error ',real(ERRMAX),' at',itry
	failw = ERRMAX .gt. EWRON
	write(79,258) (EE),(jtot),(RAFIN),(ERRMAX),(AE)
258	format(F10.5,f7.1,f9.2,1p,2e12.4)
	if(failw) then
            if(itry.le.max(2,maxtry)) 
     X		write(6,26) 'W',RAFIN,EE,ERRMAX,EWRON
26          format(' FAILED ',a1,' test at r=',f12.3,', E =',F8.4,
     X		' as',1P,E11.3,' >',E11.3)
	 else if(ERRMAX.gt.1d-8) then
            write(6,27) RAFIN,EE,ERRMAX,EWRON
27          format(' Passed W test at r=',f12.3,', E =',F8.4,
     X		' as',1P,E11.3,' <',E11.3)
	 endif
	if(failr.and..not.(failw.or.failg)) 
     X			write(6,251) RAFIN,EE,rnorm,threshr
	fail = failw .or. failr .or. failg

*
*  if the test fails and RAFIN is not at its allowed maximum try
*  extending RAFIN by a factor rfact
*
         if(fail .and. RAFIN.lt.rlwmax .and. itry.lt.maxtry) then
            gmaxp = gmax
            if(failw.or.failg) RAFIN = rfact * RAFIN
            if(failr.and..not.(failw.or.failg)) 
     X			       RAFIN = RAFIN + 1d0/sqrt(E)
            RAFIN = min(RAFIN, rlwmax)
	write(3,*) ' ASYMS: to try RAFIN =',real(RAFIN)
     X            ,', rafmax =',real(rafmax)
*
*  if necessary extend the range over which the propagator is
*  initiated otherwise redefine the new trial radius at a sector
*  end
*
            if (RAFIN .gt. rafmax) then
               r1 = rafmax
               r2 = RAFIN
c              NDONE = NFINAL
             call slwpot(NFINAL,nc,nc,
     X                PRNTV,LDEBUG,r1,r2,lwsect,lwkeep,lwran,
     X                BETA,CUPLIM,NUMAX,
     X                LCHL,CF,MCHAN,ETHR,IDISCR,DEBUG,
     X                zero,zero,LWGF,.not.FAD,NBLOCK,EFERMI)
               RAFIN = lwsect(NFINAL)
               if (NFINAL .eq. lwran) rlwmax = lwsect(lwran)
               do 50 i = NDONE + 1,NFINAL
                  keep(i) = max(lwkeep(i),nkeep)
                  keep(i) = nc
 50            continue
               isect = NFINAL
               rafmax = RAFIN
            else
               call secend (RAFIN,isect,NFINAL,lwsect,lwran)
            end if
         else
            go to 90
         end if
 60   continue
      write (iout,1130) ntry, RAFIN
c      stop
 90   if (failw) then
         if (NFINAL.lt.lwran) write (iout,1140) 'Wronskian',RAFIN
         if (NFINAL.eq.lwran) write (iout,1145) 'Wronskian',RAFIN, lwran
      else if (failr) then
         if (NFINAL.lt.lwran) write (iout,1140) ' R-matrix',RAFIN
         if (NFINAL.eq.lwran) write (iout,1145) ' R-matrix',RAFIN, lwran
      else if (failg) then
         if (NFINAL.lt.lwran) write (iout,1140) ' Gailitis',RAFIN
         if (NFINAL.eq.lwran) write (iout,1145) ' Gailitis',RAFIN, lwran
      end if
      if(.not.rafold) gmaxp = gmax
      rafprev = raf
      nopp = nop
      if(ntry.gt.1) write (iout,1150) EE,(radius(i),i=ntry,1,-1)

c      IF (PRRM.and.PRWF) THEN
       IF (PRRM) THEN


***         WRITE (IOUT,1000) RAFIN
c           CALL WRTMAT (RMAT2,NC,NC,MCHAN3,NCOL)
***         CALL WRTMATR(RMAT,NC,NC,MCHAN3,NCOL,RAFIN)
	   write(6,*) ' r*R matrix: at ',real(RAFIN)
          do 133 i=1,NC
  133      write(6,135) i,(RAFIN*RMAT(i+(j-1)*MCHAN3) , j=1,NC)
  135	   format(1x,i3,18f8.3,:,/(4x,18f8.3))
         ENDIF
	NP = min(NC,3)
      IF (PRWF) THEN
         DO 140 K = 1, 2
            WRITE (IOUT,1010) FG(K),RAFIN
            CALL WRTMAT (F(1,1,K),NC,NC,NC,NCOL)
  140    CONTINUE
         DO 150 K = 1, 2
            WRITE (IOUT,1020) FG(K),RAFIN
            CALL WRTMAT (FP(1,1,K),NC,NC,NC,NCOL)
  150    CONTINUE
      ENDIF
      IF (KM) CALL KMATM (NC,RAFIN,PPN,IOP,NOP,F,FP,RMAT,BBLOCH,KMAT)
      IF (PRKM) THEN
***         WRITE (IOUT,1030)
***         CALL WRTMAT (KMAT,NOP,NOP,MCHAN3,NCOL)
	   write(6,*) ' K matrix:'
          do 153 i=1,NC
  153      write(6,135) i,(KMAT(i+(j-1)*MCHAN3) , j=1,NC)
      ENDIF
	NP = min(NC,3)
      RETURN
*
c1000 FORMAT (' ASYMS final R-matrix at radius =',F12.3)
 1000 FORMAT (' ASYMS final r*R-matrix at radius =',F12.3)
 1010 FORMAT (' ',A1,' Solutions at RAFIN =',F12.3)
 1020 FORMAT (' ',A1,' Derivatives at RAFIN =',F12.3)
 1030 FORMAT (' K-MATRIX')
 1130 format (/' Failed to calculate accurate wave functions'/
     x        /' tried ',i3,' times.  final radius was ',f12.3/)
 1140 format (/,' *****  Warning - ',a9,' test failed  at ',f12.3,/
     x          ' The calculation continues at this radius',/,
     x          ' this radius is limited by rafix set in input.',
     x          ' *********'/)
 1145 format (/,' *****  Warning - ',a9,' test failed  at ',f12.3,/
     x          ' The calculation continues at this radius',/,
     x          ' this radius is at the end of the last possible',
     x          ' LW sector,lwran =',i4,/,
     x          ' lwran is set in subr cntrl',' *********'/)
 1150 format (12x,'energy    radii at which functions calculated',/
     x        ' At E =',1x,f12.6,4(2x,f12.5),:,/(22x,4(f12.5,:,2x)))

      END

      subroutine secend(RAFIN,isect,NFINAL,lwsect,lwran)
*
* $Id: secend.f,v 1.1 93/04/22 14:25:11 vmb Exp Locker: vmb $
*
      implicit integer (a-z)
      real*8 RAFIN,lwsect
      dimension lwsect(lwran)
         do 22 i = 1,NFINAL
            if (RAFIN .le. lwsect(i)) then
               RAFIN = lwsect(i)
               isect = i
               go to 23
            end if
 22      continue
         isect = NFINAL
 23      return
         end
