        Subroutine Probability(VAL,VEC,SS,AA,VALI,iival,it,
     x				Nstate,Abound,leig,npole)
	use globals
	use gs
	implicit real*8 (a-h,o-z)
	real*8 AA(nchmax,nchmax),SS(nchmax,numrmax)
	real*8 VAL(0:nchmax),VALI(0:nchmax),VEC(nchmax,0:nchmax),sum(4)
	real*8 psi(MCHAN),norm,perm(MCHAN),shiftd(Nstate,2),
     X		Abound(nchmax),wnorm(MCHAN),prnorm(MCHAN)
	real*8 FF(KKMAX),GG(KKMAX),FD(KKMAX),GD(KKMAX),wf2(Nstate,2)
	logical iival,bad
	integer it(Nstate),kstate(Nstate,LXTRA+1),nodes(MCHAN)
	parameter(maxlnam=12)
      	CHARACTER eigen*5,LNAMES(maxlnam),lname
	DATA LNAMES / 's','p','d','f','g','h','i','j','k','l','m','n' /

      	DATA nbs /0/

        write(6,*) ' Eigenvalues and Probabilities'
	 call chops(23)
	 bad = .false.
	if(neigs.lt.leig) return
!	if(allocated(PsiGSe)) deallocate (PsiGSe)
!	allocate (PsiGSe(Nstate,numrs))
c	write(16,99) XLA,(VAL(k),k=leig,min(10,neigs))
99  	   format(1x,f10.5,10f9.4)
	if(.not.GO) then
C                         copy gs. wavefunction & quantum numbers
100	  egs = 1d6
	  k0 = -1
          do 101 k=1,neigs
	   if(VAL(k).lt.egs.and.VAL(k).ge.egsmin) then
		  k0  = k
		  egs = VAL(k0)
		  endif
101	  continue
C				Use asymptotic-calc gs if there is one
	if(leig.eq.0) k0 = 0
	if(k0.ge.0)then
	  write(6,105) VAL(k0),k0
105       format(/' Ground state ENGY =',F13.8,' MeV  (',I4,')'/)
	 else
	  write(6,1051) egsmin
1051	  format(/' NO ground state ENGY found above ',F10.5,' MeV'/)
	  egsmin = -1d6
	  go to 100
	 endif
	egs = VAL(k0)
	nstgs = Nstate
	jtoti = jtot
	PARITI= parity
	TTGS = TT
c			These are for PsiGSe: for transitions
	stepgs = steps
	numgs = numrs
	allocate (kstgs(Nstate,LXTRA+1),ichgs(Nstate,nbody),
     X		  kfadgs(Nstate))
          do i=1,Nstate
	     kstgs(i,1) = lchl(i)
	     if(details) then
	     do ib=1,nbody
	     ichgs(i,ib) = ichl(i,ib)
	     enddo
	     kfadgs(i) = KFAD(i)
	     do lx=1,LXTRA
	     	kstgs(i,lx+1) = LXTR(lx,i)
	     enddo
	     endif
          enddo
        endif  

	   ITT=0
	   do i=1,Nstate
	    if(KFAD(i).eq.1) then
		ITT = ITT+1
		it(ITT) = i
	 	endif
	   enddo
     
          do i=1,Nstate
	     kstate(i,1) = lchl(i)
	     do lx=1,LXTRA
	     	kstate(i,lx+1) = LXTR(lx,i)
	     enddo
          enddo
	call chops(15)
	do 60 k=leig,neigs
 	if(.not.iival) write(15,*) k,VAL(k)
 	if(iival)      write(15,*) k,VAL(k),VALI(k)
          norm=0.
c	  if(VAL(k).gt.egsmax.and.k.ge.3.or.VAL(k).gt.5.) go to 40
	  if(VAL(k).gt.egsmax.and.k.ge.3.and.k.ne.k0) go to 40
c	  if(VAL(k).gt.0.0   .and.k.ge.3.and.k.ne.k0) go to 40
	  if(leig.le.0 .and. k.eq.npole) then
		write(6,*) ' Eigenstate ',k,' asymptotically improved'
		go to 40
		endif
          eigen = 'Scatt'
          if(VAL(k).lt.0) eigen = 'BOUND'
          write(6,1) eigen,jtot,PSIGN(parity+2),VAL(k),k
1         format(/' ',A5,' EIG',F5.1,A1,': ',F15.4,:,'  (',I4,')')
	   write(6,*) 'Lvals:',LCHL
		if(nsturm.eq.0) go to 40
	  sum(1:4)=0.0
	  kminfo = 1000
	  kmaxfo = 0
	  FF(:) = 0.
          do i=1,Nstate
	     wnorm(i)=0.
	     perm(i)=0.
	  	XZ=1.0
	  	if(KFAD(i).eq.2.or.KFAD(i).eq.3) XZ=0.5
             do n1=1,nsturm 
             do n2=1,nsturm
                nn1=n1+(i-1)*nsturm
                nn2=n2+(i-1)*nsturm

		   do 32 j2=1,Nstate
                     nn2=n2+(j2-1)*nsturm
		     T = VEC(nn1,k)*VEC(nn2,k) * WN1(i,j2) * AA(nn1,nn2)
                     wnorm(i)=wnorm(i)+T
		     if(abs(T)>1e-10) then
		       kminfo = min(kminfo,lchl(i)+1)
		       kmaxfo = max(kmaxfo,lchl(i)+1)
		       FF(lchl(i)+1) = FF(lchl(i)+1) + T
		     endif
32		     norm=norm+T

		 do 36 j1=1,Nstate
                   nn1=n1+(j1-1)*nsturm
		   X = VEC(nn1,k) * WN1(i,j1) * XZ*XZ
		 if(abs(X).gt.1e-20) then
		 do 35 j2=1,Nstate
                   nn2=n2+(j2-1)*nsturm
                     T = X * VEC(nn2,k)*WN1(i,j2) * AA(nn1,nn2)
                     perm(i)=perm(i)+ T
		     sum(kfad(i)) = sum(kfad(i)) + T
35		 continue
		 endif
36		 continue
              enddo
              enddo
          enddo
          do i=1,Nstate
            wnorm(i)=wnorm(i)/norm
            perm(i)=perm(i)/norm
            prnorm(i)=wnorm(i)
          enddo
	  sum(1:4) = sum(1:4)/norm
	 if(FAD) write(6,*)'  Normalised:'
          write(6,2)(i,wnorm(i),i=1,Nstate)
          write(6,*)
	  if(kmaxfo>kminfo) then
	    do i=kminfo,kmaxfo
	      if(abs(FF(i))>1e-9) write(6,'(1x,i4,f12.8)') i-1,FF(i)
	    enddo
            write(6,*)
	  endif
	 if(FAD) then
	  write(6,*)'  Permuted:'
	  write(6,2)(i,perm(i),i=1,Nstate)
          write(6,*)'    (T,Y,X,M norms =',(real(sum(i)),i=1,4),') ',
     X			real(norm)
          write(6,*)
	 endif
40	continue

	nbs = nbs + 1
	if(pralpha.and.nbs.le.10) then
	 call chops(37)
         write(37,1011) nbs-1,jtot,PSIGN(parity+2),VAL(k)
	 do n1=1,nsturm
	 cab = 0.0
	 do j=1,Nstate
	   cab = cab + abs(VEC(n1+(j-1)*nsturm,k))**2
	 enddo
	 write(37,*) n1,real(sqrt(cab))
	 enddo
         write(37,*) '&' 
	endif

 	if(VAL(k).gt.egsmax.and.k.ne.k0) go to 60
c	if(VAL(k).gt.0.0   .and.k.ne.k0) go to 60
	  if(leig.le.0 .and. k.eq.npole) go to 60
c				examine all bound states
 	write(6,106) VAL(k)
106     format('   Bound state at',F11.5,' MeV')
	if(pralpha) then
	  call chops(22)
         write(22,*) 
         write(22,1010) 'Eigen',jtot,PSIGN(parity+2),VAL(k)
	  do j=1,Nstate
	  cab = 0.0
	    do n1=1,nsturm
	    cab = max(cab,abs(VEC(n1+(j-1)*nsturm,k)))
	    enddo
	  write(22,*) 'VEC: ch=',j,', max component abs =',real(cab)
	 if(cab.lt.1e3) then
	  write(22,3) (VEC(n1+(j-1)*nsturm,k),n1=1,nsturm)
	 else
	  write(22,301) (VEC(n1+(j-1)*nsturm,k),n1=1,nsturm)
	 endif
	  enddo
	  call flush(22)
	 endif

c??	if(glag) go to 60
	if(glag) then
	  numrs1=numrs
	  endif
	sum(1) = 0.0
          do i=1,Nstate
             do irs=1,numrs1
	     	PsiGSe(i,irs)=0d0
	     enddo
	     wnorm(i) = 0.0
	  do j=1,Nstate
	     if(abs(WN1(i,j)).gt.1e-10) then
             do n1=1,nsturm 
                nn1=n1+(j-1)*nsturm
        	do irs=1,numrs1
		  ir = irs*iwfskp
                PsiGSe(i,irs)=PsiGSe(i,irs) + 
     X				WN1(i,j)*VEC(nn1,k)*SS(nn1,ir)
		if(abs(PsiGse(i,irs)).gt.10) then
		   call chops(90)
		   write(90,*) i,j,irs,WN1(i,j),VEC(nn1,k),SS(nn1,ir)
		 endif
		enddo
             enddo
             endif
          enddo
	     if(FAD) then
	     do irs=1,numrs1
		wnorm(i) = wnorm(i) + PsiGSe(i,irs)**2 * wrade(irs)
	     enddo
!				Statistics on just T-wave part:
	     if(KFAD(I).eq.1) sum(1) = sum(1)+wnorm(i)
	     endif
          enddo
C				GS wfn on extended grid (if not already):
	 if(k.ge.1) then
	     WVK = sqrt(-min(VAL(k),0d0)/ryev)
	     do i=1,Nstate
	 	cab = PsiGSe(i,numrs1)
		if(VAL(k).gt.0.) cab = 0.
		 cfp = 0d0
		 do np=1,npots
		   cfp = cfp + cf(i,i,1,np)*potcoef(np)
		 enddo
		if((abs(cfp).lt.1e-3.and.lchl(i)+scent.lt.0.01)
     X			.or.abs(cab).le.1d-50) then
		 do irs=numrs1+1,numrs
		  PsiGSe(i,irs) = cab * exp(-(rrade(irs)-Rmax)*WVK)
		 enddo
		else
	         call coul(lchl(i)+scent,-cfp*.5,-WVK**2,
     X				rrade(numrs1),fx,fxp)
		 anc = cab/fx
			fx0 = fx
		 do irs=numrs1+1,numrs
	         call coul(lchl(i)+scent,-cfp*.5,-WVK**2,
     X				rrade(irs),fx,fxp)
		  PsiGSe(i,irs) = anc * fx
	if(abs(fx).gt.abs(fx0)*2) write(6,*) 'Whit instability:',
     X     lchl(i)+scent,rrade(irs),WVK*rrade(irs),fx,fxp
		 enddo
	        endif
	     enddo
	 else if(fadex.gt.1) then
c				Find projected asymptotic wfn
  	   do 44 irs=numrs1+1,numrs
	   r = irs*steps
	   do 42 i=1,Nstate
42	    psi(i) = PsiGSe(i,irs) 
	   do i=1,Nstate
	    PsiGSe(i,irs) = 0d0
	       do j=1,Nstate
                 T = WN1(i,j)
                 if(KFAD(i).eq.2.or.KFAD(i).eq.3) T = T*0.5
	         PsiGSe(i,irs) = PsiGSe(i,irs)  + T * psi(j)
	       enddo
	   enddo
44	  continue
	 endif
	 if(FAD) then
	  write(6,*) '  T-wf (norm ',real(sum(1)),') :'
	  write(6,2) (iti,wnorm(it(iti)),iti=1,ITT)
          write(6,*) 
	 endif
c				Renormalise wfn in extended grid if required
	sum(1) = 0.0
	do 455 i=1,Nstate
	do 455 j=1,Nstate
 	  T = 0d0
	 if(abs(WN1(i,j)).gt.1e-10) then
	 do 45 irs=1,numrs
	   r = PsiGSe(i,irs)*PsiGSe(j,irs) * wrade(irs)
	   T = T + r
		if(abs(r).gt.10) then
		   call chops(90)
		   write(90,*) i,j,irs,
     x		    PsiGSe(i,irs),PsiGSe(j,irs) , wrade(irs)
		endif
45	   continue
	 endif
455	sum(1) = sum(1) + T * WN1(i,j)
	 bad = sum(1).gt.1.5
 	if(abs(sum(1)-1d0).gt.1d-5) then
	  write(6,*) '   Renormalising, as extended grid norm was ',
     X			real(sum(1))
	  T = 1d0/sqrt(sum(1))
	  do 46 i=1,Nstate
	  do 46 irs=1,numrs
46          PsiGSe(i,irs) = PsiGSe(i,irs) * T
	endif
	
	do 48 i=1,Nstate
	  nodes(i) = 1
	do 47 irs=1,numrs
	  if(irs>lchl(i)+1.and.abs(PsiGSe(i,irs))>1e-5) then
	    if(PsiGSe(i,irs)*PsiGSe(i,irs-1)<0) nodes(i)=nodes(i)+1
	  endif
47	continue
48	if(abs(prnorm(i))<1e-5) nodes(i)=0
c --------------------------------------
	if(VAL(k).gt.0d0) then
	   eimg = 0.0
	   denom = 1.
	   eps = 0.01
	   do i=1,Nstate
        	T = val(k)-ecores(i)
!		write(6,*) 'RES1: i,val(k),ecores(i),T=', i,val(k),ecores(i),T
	       if(T>0) then
        	WVK = sqrt(abs(T)/ryev)
          	rmk = rrade(numrs1) * WVK
		 cfp = 0d0
		 do np=1,npots
		   cfp = cfp + cf(i,i,1,np)*potcoef(np)
		 enddo
!		write(6,*) 'RES2: WVK,rmk,cfp =',WVK,rmk,cfp
          	etaq = cfp/(2d0 * WVK)
          	lj = lchl(i)
          	flj = dble(lj) + scent
          	fl0 = flj - int(flj)
          	lj1 = 1 + scent
          	call  coulfg(rmk,etaq,fl0,flj,ff,gg,fd,gd,1,0,ifl,m1)
!		write(3,*) 'RES3: etaq,lj,f,g =',etaq,lj,ff(lj+lj1),gg(lj+lj1)
		pen = rmk/(ff(lj+lj1)**2 + gg(lj+lj1)**2)
	   gam2 = PsiGSe(i,numrs1)**2 * ryev / rrade(numrs1)
	   wf2(i,1) = 2*gam2 * pen
	   eimg = eimg + wf2(i,1)
!		write(6,*) 'RES4: i,wf**2,pen  =',i,PsiGSe(i,numrs1)**2,pen
		write(6,14) i,PsiGSe(i,numrs1)**2,pen,wf2(i,1),eimg
14		format(' Resonance: ch #',i3,' wf^2,P,G,cum-G =',1p,4e12.3)

		shift = pen*(ff(lj+lj1)*fd(lj+lj1) + gg(lj+lj1)*gd(lj+lj1))
        	WVK = sqrt((T+eps)/ryev)
          	rmk = rrade(numrs1) * WVK
          	etaq = cfp/(2d0 * WVK)
          	call  coulfg(rmk,etaq,fl0,flj,ff,gg,fd,gd,1,0,ifl,m1)
		pen = rmk/(ff(lj+lj1)**2 + gg(lj+lj1)**2)
		shift2 = pen*(ff(lj+lj1)*fd(lj+lj1) + gg(lj+lj1)*gd(lj+lj1))
		shiftd(i,1) = (shift2-shift)/eps

		shiftd(i,2) = gam2 * shiftd(i,1)
		denom = denom + shiftd(i,2)

	       endif
	   enddo
          write(6,15) val(k),eimg,eimg/denom
15	  format('   Formal half-Width of state at ',
     X		f15.10,' is: ',1p,e12.4,' MeV, Observed =',e12.4)
     	  write(6,151) (i,shiftd(i,1),shiftd(i,2),i=1,min(10,Nstate))
151	  format('     Chan ',i3,' dS/dE =',f8.4,' gam^2*dS/dE =',f8.4)
	endif
c --------------------------------------
c         rms radius of g.s.
c --------------------------------------
	rms = 0.0
	rms4 = 0.0
	sum(1) = 0.0
	do i=1,Nstate
	do irs=1,numrs
	   T = PsiGSe(i,irs)**2 * wrade(irs)
	   sum(1) = sum(1) + T
	   rms    = rms + rrade(irs)**2 * T
	   rms4   = rms4+ rrade(irs)**4 * T
	enddo
	enddo
	rms = rms / sum(1)
	rms4= rms4/ sum(1)
	if(tmass>1e-5) then
	if(nbody.eq.3) then
	 rmstot=sqrt((mass(3)*radius(3)**2 + rms)/tmass)
	else if(nbody.eq.2) then
	 rmstot=Sqrt(mass(2)/tmass*radius(2)**2 + mass(2)/tmass/tmass*rms)
	else
	 rmstot=rms/nbody
	 rmstot=0d0      		! what is rule in general??
	endif
	rms = sqrt(rms)
	if(nbody.le.3) write(6,52) rms,rmstot,radius(nbody)
	if(nbody.gt.3) write(6,52) rms,rms/sqrt(real(nbody))
52	format( '   Rms wf =',f7.3,' fm.',:,' So rms Matter radius =',
     X		F7.3,' fm.',:,' with Rcore',F7.3,' fm.'/)
	if(nbody.eq.3.and.VAL(k).lt.5.0) then
	 write(6,'(''     Ms 4th moment ='',f10.2)') rms4
         call denanr(PsiGSe,steps,numrs,rrade,wrade,kstate,
     x   		Nstate,KFAD,VAL(k))
	endif
	else
	 rms = sqrt(rms)
	 write(6,52) rms,rms/sqrt(real(nbody))
       endif
C
c       if(lprwf.ge.1.and.(.not.GO.or.VAL(k).lt.0.0)) then
	do im=1,nmom
	  sum(1) = 0d0
	  do i=1,Nstate
	  do j=1,Nstate
	   T = 0d0
	  do irs=1,numrs
	   T = T + PsiGSe(i,irs) * PsiGSe(j,irs) * 
     X			 wrade(irs) * rrade(irs)**nlam(im)
	  enddo
	    sum(1) = sum(1) + moms(i,j,im) * T
!	    write(6,*) im,i,j,T,moms(i,j,im),sum(1)
	  enddo
	  enddo
	  write(6,53) im,nlam(im),sum(1),sqrt(abs(sum(1)))
53	format( '   Moment ',i3,' of order',i2,'  =',f10.3,
     x          ', with sqrt =',f7.3)
	enddo
	  
	call flush(6)
c        if(lprwf.ge.1.and.(.not.GO.or.VAL(k).lt.0.0.or.k.eq.k0)) then
c        if(lprwf.ge.1.and.(.not.GO.or.VAL(k).lt.egsmax.or.k.eq.k0)) then
        if(lprwf.ge.1.and.(.not.GO.or.VAL(k).lt.egsmax)) then
C
C	write out g.s. wavefunction, file 11 for plotting, file 18 binary:
	   call chops(11)
      	   write(11,4001)jtot,PSIGN(parity+2),VAL(k),ITT,LXTRA,ryev,
     x                   qnum(1:LXTRA+1)
4001  	   format('# Bound ',f5.1,a1,' state at',f10.5,' MeV,',2i3,f10.6/,
     x            '#    i:   norm   n ',(30(a3,2x)))
	   do 4130 ich=0,ITT-1,10
	    do 4002 i=1,min(ITT-ich,10)
	      l = kstate(it(i+ich),1)
	      lname = ' '
	      if(l<maxlnam.and.nodes(it(i+ich))>0) lname = LNAMES(l+1)
!4002   write(11,4003) it(i+ich),(kstate(it(i+ich),lx),lx=1,LXTRA+1)
4002   	    write(11,4003) it(i+ich),prnorm(it(i+ich)),nodes(it(i+ich)),
     x       lname,l,(kstate(it(i+ich),lx)/real(mult(lx)),lx=2,LXTRA+1)
4003  	    format('# ',i4,':',f8.5,i3,a1,i3,20f5.1)
      	   do 4120 irs=1,numrs
4120  	   write(11,4122) rrade(irs),(PsiGSe(it(iti+ich),irs),
     X					iti=1,min(ITT-ich,10))
c4121  	   format(1x,f8.3,10g12.3)
c4121  	   format(1x,f8.3,10f9.5)
4121  	   format(1x,f8.3,1p,10e12.4)
4122  	   format(1x,f8.3,1p,10e14.6)
4130   	   write(11,*) '&'
	   call flush(11)
C!!     call chopb(18)
c!!	write(18) ((PsiGSe(it(iti),irs),irs=1,numrs),iti=1,ITT)
	endif

c		CALCULATE AVERAGE EFFECTIVE SINGLE-CHANNEL POTENTIAL
c			e.g. for using as sturmian potential:
c	if(sturm(kst).eq.'T'.and.nbs.le.10) then
	if(nbs.le.10) then
	 call chops(38)
         write(38,1011) nbs-1,jtot,PSIGN(parity+2),VAL(k)
	 do 55 irs=1,numrs
	   r = rrade(irs)
	   X = 0.0
	   T = 0.0
	   do 50 i=1,Nstate
	    X = X + PsiGSe(i,irs)**2
c	     if(pertcent) T = T + PsiGSe(i,irs)**2 * ryev * 
c    &             ( (LCHL(i)+scent)*(LCHL(i)+scent+1d0)
c    &                - scent*(scent+1d0) )/r**2
	    do 50 j=1,Nstate
50		T = T + PsiGSe(i,irs) * VVAL(i,j,r) * PsiGSe(j,irs)
55	  write(38,*) real(r),T/(X+1d-50)    
          write(38,*) '&' 
	   call flush(38)
	 endif

C Write to file 19 all bound states below egsmin (for Boris Danilin)
c!!	if(VAL(k).lt.egsmin)
c!!  x    write(19) ((PsiGSe(it(iti),irs),irs=1,numrs),iti=1,ITT)

C Write to file 18 the g.s. wavefunction in T basis:
        if(.not.GO.and.k.eq.k0.and.val(k).lt.0..and.details)  then
		write(6,*) ' Writing eigenstate ',k,' as g.s.'
		call chopb(48)
     		write(48) ((PsiGSe(i,irs),irs=1,numrs),i=1,Nstate)

		write(6,*) ' Writing eigenstate ',k,' info to file 78'
		call chopb(78)
		rewind 78
		write(78) egs,nstgs,LXTRA,jtoti,PARITI,TT,
     x			nbody,FAD,numrs,steps
		write(6,*) ' Writing ',nstgs,' chs of ',numrs,' points'
	write(6,*) ' Number of bodies: ',nbody,'; Faddeev gs: ',FAD,
     x   '; lxtgs,nstgs =',LXTRA,nstgs
        write(6,*) ' numrs: ',numrs,'; steps: ',real(steps)

		do 58 i=1,nstgs
		write(78) (ICHL(i,ib),ib=1,nbody),
     X			  (kstgs(i,j),j=1,LXTRA+1)
		if(FAD) write(78) kfadgs(i)
58      	write(78) (PsiGSe(i,irs),irs=1,numrs)
		close(78)
!		close(48)

		GO = .true.
		kst = 2
	   endif
60	continue
	deallocate (PsiGSe)
	if(.not.GO) deallocate(kstgs,ichgs,kfadgs)
 	write(15,*) '&'
	call flush(15)

	if(GO) then
C After any J/pi combination,
C read back from file 48 the g.s. wavefunction for B(Ek) transitions later
c	call chopb(48)
	rewind 48
	allocate (PsiGSe(nstgs,numrs))
       	read(48) ((PsiGSe(i,irs),irs=1,numrs),i=1,nstgs)
	endif
C Assume g.s. is the lowest eigenstate of first J/pi combination => found.
C NOT!
C NOT!	GO = .true.
         
1010       format('# ',A5,' EIG',F5.1,A1,': ',F15.8,:,'  (',I4,')')
1011    format('@legend string ',I3,' "',F5.1,A1,' @ E=',F10.5,' MeV "')
c2       format(5F15.7)
c2       format(4(i3,G15.6,','))
2       format(4(i4,F14.10,','))
3       format(10F10.5)
301     format(10F10.1)
	if(bad) then
	    write(6,*) ' GS asymptotic norm too large: bad eigenstate'
	    stop
	    endif
!	 close(38)
       return
       end
 	subroutine enorm(VEC,nchmax,neigs,WN1,MCHAN,VAL,
     X			 SS,numr,nch,nsturm,wrad,AA,pvec,mdiag)
	implicit real*8 (a-h,o-z)
	real*8 AA(nchmax,nchmax),SS(nchmax,numr),VAL(nchmax)
	real*8 VEC(nchmax,nchmax),WN1(MCHAN,MCHAN),norm,wrad(numr)
	real*8 pvec(nchmax)
	logical mdiag
 	parameter (thresh=0.001,degeny=1e-6)
c	parameter (thresh=0.04,degeny=1e-6)
c	parameter (thresh=0.0)

C	Calculate norm matrix AA valid also when WN1 ne I
C	Normalise 'neigs' eigenvectors to physical normalisation
c	Omit eigensolutions if
C	either (1) norm is less than  'thresh'
C	    or (2) eigenvalue closer than 'degeny' to previous eigensolution

c ------------------------------------------------
c       matrix elements for AA=<SS|SS> without factor WN1(i,i')
c ------------------------------------------------
	Nstate = nch/nsturm

 	do k1=1,nch
          kv1=(k1-1)/nsturm+1
	  n1 = mod(k1-1,nsturm)+1
	  do k2=1,k1
	    kv2=(k2-1)/nsturm+1
	    n2 = mod(k2-1,nsturm)+1
 	    AA(k1,k2)=0.
	    if(mdiag.and.kv1.eq.kv2.and.n1.ne.n2) go to 10
            if (WN1(kv1,kv2).ne.0d0) then
	    do i=1,numr
	      AA(k1,k2)=AA(k1,k2)+wrad(i)*SS(k1,i)*SS(k2,i)
	    enddo
	    endif
10          AA(k2,k1)=AA(k1,k2)
          enddo
	enddo
	smallincl = 1e8
	bigmiss   = 0.0
	kto = 0
	write(6,12) thresh
12	format(/' Renormalising eigenstates with threshold =',1p,e12.2)

	do 60 k=1,neigs
          norm=0.
          do 30 i=1,Nstate
     	  do 30 j=1,Nstate
	   if (WN1(i,j).eq.0d0) go to 30
             do 20 n1=1,nsturm 
             do 20 n2=1,nsturm
		if(mdiag.and.i.eq.j.and.n1.ne.n2) go to 20
                nn1=n1+(i-1)*nsturm
                nn2=n2+(j-1)*nsturm
		T = VEC(nn1,k)*VEC(nn2,k) * WN1(i,j) * AA(nn1,nn2)
	        norm=norm+T
20	     continue
30	     continue
	   call chops(23)
 	  write(23,35) k,VAL(k), norm,kto+1
35 	  format(' Eigenstate ',i5,' @',f11.4,
     x			' has norm ',1p,g12.3,' ->',i5)
	  norm = abs(norm)
	  if(norm.lt.thresh) then
		bigmiss = max(bigmiss,norm)
		go to 60
		endif
	  smallincl = min(smallincl,norm)
	   do 36 ito=1,kto
	   if(abs(VAL(ito)-VAL(k)).lt.degeny) then
	     write(23,*) '      OMITTED, as degenerate with ',ito
	     go to 60
	   endif
36	   continue
	  kto = kto + 1
c	  write(26,*) real(VAL(k)),' has norm ',real(norm),kto,k
	 if(norm.gt.0d0) then
	  T = 1d0/sqrt(abs(norm))
	 else
	  T = 1.0
	 endif
	  do 40 nn1=1,nch
40	  VEC(nn1,kto) = VEC(nn1,k) * T
	  VAL(kto) = VAL(k)
60	 continue
	 if(kto.ne.neigs) write(6,70) neigs,kto,bigmiss,smallincl
70	 format(' Eigenstates reduced from ',I4,' to',I4,';',/,
     x	'  biggest omitted =',1p,e12.2,' & smallest included =',e12.2/)
	 neigs = kto
	return
	end
