      SUBROUTINE SPBE(FUL,EC,KSTHE,NSTHE,IOP,NOP,FUH,LL,TRCHAN,
     X			SOME,CONT)
	use globals
	use gs
	use scattering
      IMPLICIT real*8 (A-H,O-Z)
      INTEGER IOP(NOP)
      REAL*8 SI,SF,JI,JF,ICI,ICF
      LOGICAL SOME,CONT

C    ***********************************************************
C  CALCULATION OF B(E0,1) AS A FUNCTION OF KINETIC ENERGY OF REACTION
C  PRODUCTS FOR 1-BODY CONTINUUM, initial JTOTI
C
C    ***********************************************************
C *** L,s,j,I - QUANTUM NUMBER    IN ARRAY
      DIMENSION KSTHE(MCHAN3,7)
      COMPLEX*16 FUH,TRCHAN(MNOP,MCHAN3,nstgs),SU,SUM(MCHAN)
      DIMENSION FUL(nstgs,NMAXF),FUH(MNOP,MCHAN3,NMAX),BECH(MCHAN)
C
      Z = 0d0
      HF = 0.5d0
      PI = 4d0*atan(1d0)
C########################################################### for sturmme:
      NM = numrs
      H = steps
	if(glag) NM=numr
      RM = NM*H
      IMAX = NM

      IMAGS = numgs
      HGS = stepgs
      RMGS = IMAGS*HGS
!				Get information from globals for local use:
!				Assumes 1 is nucleon, 2 is core!
	A1 = mass(1)
	A3 = mass(2)
	RCORE = radius(2)
	Z1 = charge(1)
	Z3 = charge(2)
C    *******************************************************************
	SOME = .false.
C ***   IE - MULTIPOLARITY OF TRANS
       IEMIN = nint(abs(JTOT - JTOTI))
       IEMAX = nint(abs(JTOT + JTOTI))
       do 1000 IE=IEMIN,IEMAX
       if((-1)**IE .ne. PARITY*PARITI) go to 1000
       if(e1only.and.IE.ne.LL) go to 1000
c      WRITE(4,151) IE,JTOTI,JTOT,PSIGN(PARITY+2)
c      WRITE(10,151) IE,JTOTI,JTOT,PSIGN(PARITY+2)
c      WRITE(50+IE,151) IE,JTOTI,JTOT,PSIGN(PARITY+2)
  151 FORMAT('# B(E',I1,') for J=',f5.1,' ->',f5.1,A1)
C    *******************************************************************
       XAPL =SQRT(DABS(EGS)/ryev)
       XAP=DSQRT(abs(EC)/ryev)
       DEN= 1D0/(ryev*XAP*2d0)

      ASUM = A1 + A3
      AL0 = 1D0/(4D0*PI)
c     AL1 = (Z3 * (A1/ASUM)**IE)**2 * (2*JTOT+1)/(2*JTOTI+1)
      AL1 = (Z3*(A1/ASUM)**IE + Z1*(-A3/ASUM)**IE)**2
     x		* (2*JTOT+1)/(2*JTOTI+1)
      WFN = 1D0/(2D0*PI)
      FAC = AL0 * AL1 
      if(CONT) FAC = FAC * DEN * WFN
c     write(4,*) 'DEN,AL1,WFN =',real(DEN),real(AL1),real(WFN)
CC
C
      DO I = 1,MCHAN
        BECH(I) = 0.D0
        SUM(I) = 0.D0
      END DO
C
C ****** LOOP ON CONTNUUS SPECTRA (IMPULS)
C
       DO 2200  JFK = 1,NOP
C
C ****** LOOP ON CONTNUUS SPECTRA  (RADIUS)
      DO 2002  IF = 1,NSTHE
       LF = KSTHE(IF,1)
        SF = KSTHE(IF,2) * HF
         JF = KSTHE(IF,3) * HF
          ICF = KSTHE(IF,4) * HF
C ****** LOOP ON DISCRET SPECTRA
      DO 2003  II = 1,NSTGS
       LI = KSTGS(II,1)
        SI = KSTGS(II,2) * HF
         JI = KSTGS(II,3) * HF
          ICI = KSTGS(II,4) * HF
C *****  GENERAL CHECK ON INACTIVE Q.N.
        IF(SI .NE. SF) GO TO 2003
         IF(ICF .NE. ICI) GO TO 2003
          IF(abs(LI-LF).gt.IE) GO TO 2003
C
      W1 = WRACA(JTOT,JTOTI,JF,JI,IE+Z,ICI)
      W2 = WRACA(JF,JI,LF+Z,LI+Z,IE+Z,SI)
      W3 = CLEB6(LF+Z,Z,LI+Z,Z,IE+Z,Z)*(-1)**(LI-LF)/SQRT(2.*IE+1.)
      W4 = (-1)**NINT(ICI+SI+LI+LF+2*JI+2*JF) 
     X     * sqrt((2*JTOTI+1)*(2*JI+1)*(2*JF+1)*(2*LI+1)*(2*LF+1)
     X     		* (2*IE+1))
      W = W1 * W2 * W3 * W4
c         IF(W .EQ. 0.D0) GO TO 2020

        SU = 0.D0
C
	if(e1only) then
	  SU = TRCHAN(JFK,IF,II)
	else
      DO  I=1,IMAX
	 R1 = rrade(I)
	 H = wrade(I)
        IF(I.lt.IMAGS) then
            FULLL = FUL(II,I)
        else
            R12 = R1
            FULLL = FUL(II,IMAGS)*DEXP(XAPL*(RMGS-R12))
        endif
        SU = FUH(JFK,IF,I)*FULLL*H * R1**IE +SU
        END DO
      endif
C
c     WRITE(4,100) (KSTGS(IF,M21),M21=1,4),(KSTHE(II,M1),M1=1,4)
c    *             ,SU,W1,W2,W3,W4
c100  FORMAT(' <GS',4I2,' |SU,W|',4I2,' E>=',2G10.3,4f8.4)
c     WRITE(4,100) LI,JI,ICI, LF,JF,ICF, SU,W1,W2,W3,W4
c100  FORMAT(' <GS',I3,2f4.1,' |SU,W|',I3,2f4.1,' E>=',2G10.3,4f8.4)

C  *** PARTIAL
	
        SUM(JFK) = SUM(JFK) + SU * W
C
c      if(jfk.le.2) write(2,33) EC,JFK,IF,II,
c     X       W,su,iii,sup,sum(jfk)
c33    format('BE:',f6.3,i3,2i2,';',4f8.4,I3,4f8.4)
 2020     CONTINUE
 2003     CONTINUE
 2002     CONTINUE
 2200     CONTINUE
CC
C   **** SUM OF B(E1) CALCUL   ********************************
        BEL = 0.D0
        DO JFK = 1,NOP
          BECH(JFK) =abs(SUM(JFK))**2 * FAC
          BEL = BEL + BECH(JFK)
        END DO
C
        if(IE.eq.1) WRITE(10,378) EC,BEL
          WRITE(50+IE,379) EC,BEL,(BECH(JFK),JFK=1,min(NOP,6))
378 	format(f9.5,f10.6,6f9.6)
379 	format(f9.5,7g11.3)
C   **** END OF B(Ek) CALCUL   ********************************
	SOME = .true.
1000    continue
        END
